<?php

namespace App\Http\Livewire;

use Gloudemans\Shoppingcart\Facades\Cart;
use App\Models\customer;
use App\Models\currency;
use App\Models\way_pay;
use App\Models\type_voucher;
use App\Models\habitacion_aula_mesa;
use App\Models\setting;
use Illuminate\Support\Facades\DB;
use Livewire\Component;
use Illuminate\Http\Request;

class Addsalewire extends Component
{
    public $customer_sale;
    public $id_currency=1;
    public $type_comprobante;
    public $placa='';
    public $orden_compra='';
    public $mesa_habit=null;
    public $add_way_pay=1;
    public $note_sale;

    public function render(Request $request)
    {
        $datosSistem['customer'] = customer::
        select('id', 'ruc', 'dni', 'nombre')
        ->where('estado',1)
        ->get();

        $datosSistem['currency'] = currency::select('id', 'descripcion', 'codigo')
        ->where('estado',1)
        ->get();

        $datosSistem['way_pay'] = way_pay::select('id', 'descripcion', 'codigo')
        ->where('estado',1)
        ->get();

        $datosSistem['type_voucher'] = type_voucher::select('id', 'descripcion')
        ->where('estado',1)
        ->get();

        $setting = setting::
        select('id_type_business')
        ->get();

        $datosSistem['tipo_negocio'] = 0;
        foreach($setting as $rowSetting){
            $datosSistem['tipo_negocio'] = $rowSetting->id_type_business;
        }

        $datosSistem['habitacion_aula_mesa'] = habitacion_aula_mesa::select('id', 'name')
        ->where('estado',1)
        ->where('id_local', $request->session()->get('local'))
        ->get();

        return view('livewire.addsalewire',compact('datosSistem'));
    }

    public function register_sale(Request $request){

        $json_items= '';
        $datos_menu['carrito']=Cart::content();
        foreach($datos_menu['carrito'] as $carrito){
            $products[] = array(
                'id' => ((strpos($carrito->id, '_')) ? 0 : $carrito->id),
                'name' => $carrito->name,
                'price' => $carrito->price,
                'qty' => $carrito->qty,
                'tipo_impuesto' => $carrito->options->tipo_impuesto,
                'tipo_unidad' => $carrito->options->tipo_unidad,
            );
        }

        $json_items = json_encode($products);

        DB::select('CALL set_post_sales_v1(?,?,?,?,?,?,?,?,?,?,?)', [
        auth()->user()->id, 
        $this->customer_sale,
        $this->type_comprobante,
        $this->id_currency,
        $this->note_sale,
        $this->add_way_pay,
        $this->placa,
        $this->orden_compra, 
        $this->mesa_habit,
        $request->session()->get('local'),
        $json_items
        ]);

        Cart::destroy();

        $this->reset([
        'customer_sale', 
        'id_currency',
        'type_comprobante', 
        'placa',
        'orden_compra', 
        'mesa_habit',
        'add_way_pay', 
        'note_sale'
        ]);
        $this->emit('render');
        $this->emit('alertOK','Se edito el almacén con exito.');
    }
}
