<?php

namespace App\Http\Livewire;

use App\Models\product;
use App\Models\warehouses;
use Illuminate\Support\Facades\DB;
use Carbon\Carbon;
use Livewire\Component;
use Livewire\WithPagination;

class Addtrasladoswire extends Component
{
    use WithPagination;
    protected $paginationTheme = 'bootstrap';
    public $warehouses_id;

    public $searchId;
    public $search_codigo;
    public $search_nombre;
    public $search_categoria;
    public $search_marca;
    public $search_stock;

    public $almacen_destino=0;
    public $product_select=[];
    public $new_stock=[];

    protected $listeners=['render'=>'render'];

    public function render()
    {
        if($this->search_codigo == null || $this->search_codigo == ''){
            $datosSistem['producto'] = product::
            select('product.id','product.codigo','product.nombre','category.name as nameCategoria','mark.name as nameMarca','warehouses_stock.stock')
            ->leftJoin('category', 'category.id', '=', 'product.id_categoria' )
            ->leftJoin('mark', 'mark.id', '=', 'product.id_marca')
            ->leftJoin('warehouses_stock', 'warehouses_stock.id_product', '=', 'product.id')
            ->where('product.id','like', '%'.$this->searchId.'%')
            ->where('product.nombre','like', '%'.$this->search_nombre.'%')
            ->where('category.name','like', '%'.$this->search_categoria.'%')
            ->where('mark.name','like', '%'.$this->search_marca.'%')
            ->where('warehouses_stock.stock','like', '%'.$this->search_stock.'%')
            ->where('warehouses_stock.id_warehouses',$this->warehouses_id)
            ->where('product.estado', 1)
            ->orderBy('product.id','desc')
            ->paginate(10);
        }else{
            $datosSistem['producto'] = product::
            select('product.id','product.codigo','product.nombre','category.name as nameCategoria','mark.name as nameMarca','warehouses_stock.stock')
            ->leftJoin('category', 'category.id', '=', 'product.id_categoria' )
            ->leftJoin('mark', 'mark.id', '=', 'product.id_marca' )
            ->leftJoin('warehouses_stock', 'warehouses_stock.id_product', '=', 'product.id')
            ->where('product.id','like', '%'.$this->searchId.'%')
            ->where('product.codigo','like', '%'.$this->search_codigo.'%')
            ->where('product.nombre','like', '%'.$this->search_nombre.'%')
            ->where('category.name','like', '%'.$this->search_categoria.'%')
            ->where('mark.name','like', '%'.$this->search_marca.'%')
            ->where('warehouses_stock.stock','like', '%'.$this->search_stock.'%')
            ->where('warehouses_stock.id_warehouses',$this->warehouses_id)
            ->where('product.estado', 1)
            ->orderBy('product.id','desc')
            ->paginate(10);
        }

        $datosSistem['warehouses'] = warehouses::
        select('id','name')
        ->where('estado', 1)
        ->where('id','!=', $this->warehouses_id)
        ->get();

        $datosSistem['producto_trasladar'] = product::
        select('product.id','product.codigo','product.nombre','warehouses_stock.stock')
        ->leftJoin('warehouses_stock', 'warehouses_stock.id_product', '=', 'product.id')
        ->where('warehouses_stock.id_warehouses',$this->warehouses_id)
        ->whereIn('product.id', $this->product_select)
        ->where('product.estado', 1)
        ->get();

        return view('livewire.addtrasladoswire', compact('datosSistem'));
    }

    public function save(){

        $validSelect=0;
        foreach($this->product_select as $rowSelectValid){
            $validSelect++;
        }

        $validAlmDest=0;
        if($this->almacen_destino==0){
            $validAlmDest++;
        }

        if($validSelect>0 && $validAlmDest==0){

            $validCantStock=0;
            foreach($this->product_select as $rowSelectValidStock){
                if(isset($this->new_stock[$rowSelectValidStock])){
                    if($this->new_stock[$rowSelectValidStock]=="" || $this->new_stock[$rowSelectValidStock]==0 || 
                    !is_numeric($this->new_stock[$rowSelectValidStock]) || $this->new_stock[$rowSelectValidStock]==null){
                        $validCantStock++;
                    }
                }else{
                    $validCantStock++;
                }
            }

            if($validCantStock==0){
                $mytime = Carbon::now();
        
                $fecha_reg=$mytime->toDateTimeString();
                
                foreach($this->product_select as $rowSelect){
                    
                    DB::select('CALL mov_stock_warehouse(?,?,?,?,?,?)', 
                            [auth()->user()->id, 
                            $fecha_reg, 
                            $this->warehouses_id,
                            $this->almacen_destino,
                            $rowSelect,
                            $this->new_stock[$rowSelect]
                            ]);
                }
    
                $this->reset(['product_select', 'almacen_destino','new_stock']);
                $this->emit('render');
                $this->emit('cerrarModal');
                $this->emit('alertOK','Se realizo el traslado.');
            }else{
                $this->emit('alertError','se debe ingresar una cantidad de traslado para cada producto seleccionado');
            }

        }else{
            if($validAlmDest>0){
                if($validSelect==0){
                    $this->emit('alertError','se debe seleccionar un almacen destino y al menos un producto');
                }else{
                    $this->emit('alertError','se debe seleccionar un almacen destino');
                }
            }else{
                $this->emit('alertError','se debe seleccionar al menos un producto');
            }
            
        }

    }

    public function updatingSearchid(){
        $this->resetPage();
    }

    public function updatingSearchcodigo(){
        $this->resetPage();
    }

    public function updatingSearchnombre(){
        $this->resetPage();
    }

    public function updatingSearchcategoria(){
        $this->resetPage();
    }

    public function updatingSearchmarca(){
        $this->resetPage();
    }

    public function updatingSearchstock(){
        $this->resetPage();
    }

}
