<?php

namespace App\Http\Livewire;

use App\Models\customer;
use App\Models\customer_habaulmes;
use App\Models\habitacion_aula_mesa;
use App\Models\setting;
use Livewire\Component;
use Illuminate\Http\Request;

class Asigmesahabwire extends Component
{
    public $id_mesa_hab=0;
    public $id_customer_cuenta;

    public function render(Request $request)
    {
        $datosSistem['customer'] = customer::
        select('id','nombre','ruc')
        ->where('estado', 1)
        ->orderBy('id','asc')
        ->get();

        $setting = setting::
        select('id_type_business')
        ->get();

        $tipo_negocio=0;
        foreach($setting as $rowSetting){
            $tipo_negocio = $rowSetting->id_type_business;
        }

        if($tipo_negocio==3){
            $datosSistem['descripcion']='MESA';
            $datosSistem['icon']='fa fa-cutlery';
        }

        if($tipo_negocio==4){
            $datosSistem['descripcion']='HABITACIÓN';
            $datosSistem['icon']='fa fa-suitcase';
        }

        $datosSistem['habitacion_aula_mesa'] = habitacion_aula_mesa::
        select('name','habitacion_aula_mesa.id')
        ->join('local as localHAM', 'localHAM.id', '=', 'habitacion_aula_mesa.id_local' )
        //->leftJoin('customer_habaulmes as cus_habaulmes', 'cus_habaulmes.id_aulaHM', '=', 'habitacion_aula_mesa.id' )
        ->where('localHAM.id', $request->session()->get('local'))
        ->where('habitacion_aula_mesa.estado', 1)
        ->orderBy('habitacion_aula_mesa.id','desc')
        ->distinct()
        ->get();

        return view('livewire.asigmesahabwire', compact('datosSistem'));
    }

    public function agregarCuenta($id){
        $this->id_mesa_hab = $id;
    }

    public function CrearCuentaCliente(){
        customer_habaulmes::create([
            'id_customer' => $this->id_customer_cuenta,
            'id_aulaHM' => $this->id_mesa_hab,
            'date_inicial' => date('Y-m-d H:i:s'),
            'user_create'=>auth()->user()->id,
            'user_update'=>auth()->user()->id,
            'estado' => 1
        ]);
        $this->reset(['id_customer_cuenta','id_mesa_hab']);
        $this->emit('cargarCuentaMesa');
    }

}
