<?php

namespace App\Http\Livewire;

use App\Models\habitacion_aula_mesa;
use App\Models\local;
use App\Models\section;
use Livewire\Component;
use Livewire\WithPagination;

class Aulaswire extends Component
{
    use WithPagination;
    protected $paginationTheme = 'bootstrap';

    public $searchId;
    public $search_descripcion;
    public $search_name;
    public $search_fecha;
    public $search_local;

    public $searchIdSeccion;
    public $search_descripcionSeccion;
    public $search_fechaSeccion;
    public $search_nameSeccion;

    public $descripcion;
    public $id_local=1;

    public $nombre_seccion;

    public $titulo='Agregar Aula';
    public $btn='Registrar';

    public $titulo_seccion='Agregar Sección';
    public $btn_seccion='Registrar Sección';

    public $id_eliminar;
    public $id_habit_mesa_aula=0;

    public $nameSeccionSelect;
    public $idSeccionSelect;
    public $id_seccion=0;

    public $id_eliminar_seccion;

    protected $listeners=['render'=>'render'];

    protected $rules=[
        "descripcion"=>"required"
    ];

    protected $messages = [
        'descripcion.required' => 'se debe ingresar una descripción.'
    ];

    public function render()
    {
        $datosSistem['habitacion_aula_mesa'] = habitacion_aula_mesa::
        select('habitacion_aula_mesa.id','habitacion_aula_mesa.name as descripcion','local.nombre','users.name', 'habitacion_aula_mesa.updated_at')
        ->join('users', 'users.id', '=', 'habitacion_aula_mesa.user_update' )
        ->join('local', 'local.id', '=', 'habitacion_aula_mesa.id_local' )
        ->where('habitacion_aula_mesa.id','like', '%'.$this->searchId.'%')
        ->where('habitacion_aula_mesa.name','like', '%'.$this->search_descripcion.'%')
        ->where('users.name','like', '%'.$this->search_name.'%')
        ->where('habitacion_aula_mesa.updated_at','like', '%'.$this->search_fecha.'%')
        ->where('local.nombre','like', '%'.$this->search_local.'%')
        ->where('habitacion_aula_mesa.estado', 1)
        ->orderBy('habitacion_aula_mesa.id','desc')
        ->paginate(10, ['*'], 'habitacion_aula_mesa');

        $datosModal['section'] = section::
        select('section.id','section.descripcion','users.name', 'section.updated_at')
        ->join('users', 'users.id', '=', 'section.user_update' )
        ->where('section.id_aulaHM','=', $this->idSeccionSelect)
        ->where('section.id','like', '%'.$this->searchIdSeccion.'%')
        ->where('section.descripcion','like', '%'.$this->search_descripcionSeccion.'%')
        ->where('users.name','like', '%'.$this->search_fechaSeccion.'%')
        ->where('section.updated_at','like', '%'.$this->search_nameSeccion.'%')
        ->where('section.estado', 1)
        ->orderBy('section.id','desc')
        ->paginate(10, ['*'], 'section');

        $datosSistem['local'] = local::
        select('id','nombre')
        ->where('estado', 1)
        ->orderBy('id','asc')
        ->get();

        return view('livewire.aulaswire', compact('datosSistem'), compact('datosModal'));
    }

    public function save(){

        $this->validate();

        if($this->id_habit_mesa_aula==0){
            $identificador_alumno = habitacion_aula_mesa::
            select('id')
            ->where('name', trim($this->descripcion))
            ->where('id_local', $this->id_local)
            ->where('estado',1)
            ->get();
    
            $validExist=0;
            foreach($identificador_alumno as $row){
                $validExist++;
            }

            if($validExist==0){
                habitacion_aula_mesa::create([
                    'name'=>trim($this->descripcion),
                    'id_local'=>$this->id_local,
                    'estado'=>1,
                    'user_create'=>auth()->user()->id,
                    'user_update'=>auth()->user()->id
                ]);

                $this->reset(['descripcion','id_local','btn','id_eliminar','id_habit_mesa_aula','titulo']);
                $this->emit('render');
                $this->emit('alertOK','Se registro el Aula con exito.');
            }else{
                $this->emit('alertError','La descripción del Aula fue utilizado anteriormente.');
            }
            
        }else{

            $identificador_alumno = habitacion_aula_mesa::
            select('id')
            ->where('name', trim($this->descripcion))
            ->where('id_local', $this->id_local)
            ->where('estado',1)
            ->where('id','!=',$this->id_habit_mesa_aula)
            ->get();
    
            $validExist=0;
            foreach($identificador_alumno as $row){
                $validExist++;
            }

            if($validExist==0){
                habitacion_aula_mesa::where('id',$this->id_habit_mesa_aula)
                ->update([
                    'name'=>trim($this->descripcion),
                    'id_local'=>$this->id_local,
                    'user_update'=>auth()->user()->id
                ]);

                $this->reset(['descripcion','id_local','btn','id_eliminar','id_habit_mesa_aula','titulo']);
                $this->emit('render');
                $this->emit('alertOK','Se modifico el Aula con exito.');
            }else{
                $this->emit('alertError','La descripción del Aula fue utilizado anteriormente.');
            }

        }
    }

    public function modificarID($id){
        $this->id_habit_mesa_aula=$id;

        $habitacion_aula_mesa = habitacion_aula_mesa::
        select('name','id_local')
        ->where('id', $id)
        ->get();

        foreach($habitacion_aula_mesa as $row){
            $this->descripcion=$row->name;
            $this->id_local=$row->id_local;
        }

        $this->titulo='Editar Aula N° '. $id;
        $this->btn='Editar';

    }

    public function eliminarID($id){
        $this->id_eliminar=$id;
    }

    public function delete_customer(){
        habitacion_aula_mesa::where('id',$this->id_eliminar)
        ->update([
        'estado'=>0,
        'user_update'=>auth()->user()->id]);

        $this->reset(['descripcion','id_local','btn','id_eliminar','id_habit_mesa_aula','titulo']);
        $this->emit('render');
        $this->emit('alertOK','Se elimino el Aula con exito.');
    }

    public function limpiar(){

        $this->reset(['descripcion','id_local','btn','id_eliminar','id_habit_mesa_aula','titulo']);
        $this->emit('render');
    }

    public function secciones($id){
        $this->reset(['idSeccionSelect','searchIdSeccion','search_descripcionSeccion','search_fechaSeccion','search_nameSeccion']);
        $this->idSeccionSelect=$id;

        $habitacion_aula_mesa = habitacion_aula_mesa::
        select('name')
        ->where('id', $id)
        ->get();

        foreach($habitacion_aula_mesa as $row){
            $this->nameSeccionSelect=$row->name;
        }
    }

    public function save_seccion(){
        if($this->nombre_seccion==null || trim($this->nombre_seccion)==""){
            $this->emit('alertError','se debe ingresar un nombre para la sección.');
        }else{
            if($this->id_seccion==0){
                $section = section::
                select('id')
                ->where('descripcion', trim($this->nombre_seccion))
                ->where('id_aulaHM', $this->idSeccionSelect)
                ->where('estado',1)
                ->get();
        
                $validExist=0;
                foreach($section as $row){
                    $validExist++;
                }
        
                if($validExist==0){
                    section::create([
                        'descripcion'=>trim($this->nombre_seccion),
                        'id_aulaHM'=>$this->idSeccionSelect,
                        'estado'=>1,
                        'user_create'=>auth()->user()->id,
                        'user_update'=>auth()->user()->id]);
                    
                    $this->reset(['nombre_seccion','titulo_seccion','btn_seccion','id_seccion','id_eliminar_seccion']);
                    $this->emit('render');
                    $this->emit('alertOK','Se registro el Aula con exito.');
                }else{
                    $this->emit('alertError','La descripción de la sección fue utilizada anteriormente.');
                }
            }else{
                $section = section::
                select('id')
                ->where('descripcion', trim($this->nombre_seccion))
                ->where('id_aulaHM', $this->idSeccionSelect)
                ->where('estado',1)
                ->where('id','!=',$this->id_seccion)
                ->get();
        
                $validExist=0;
                foreach($section as $row){
                    $validExist++;
                }
        
                if($validExist==0){
                    section::where('id',$this->id_seccion)
                    ->update([
                        'descripcion'=>trim($this->nombre_seccion)]);
                    
                    $this->reset(['nombre_seccion','titulo_seccion','btn_seccion','id_seccion','id_eliminar_seccion']);
                    $this->emit('render');
                    $this->emit('alertOK','Se modifico la sección con exito.');
                }else{
                    $this->emit('alertError','La descripción de la sección fue utilizada anteriormente.');
                }
            }
        }
    }

    public function modificarID_seccion($id){
        $this->id_seccion=$id;

        $section = section::
        select('descripcion')
        ->where('id', $id)
        ->get();

        foreach($section as $row){
            $this->nombre_seccion=$row->descripcion;
        }

        $this->titulo_seccion='Editar Sección N° '. $id;
        $this->btn_seccion='Editar Sección';

    }

    public function eliminarID_seccion($id){
        $this->id_eliminar_seccion=$id;
    }

    public function delete_customer_seccion(){
        section::where('id',$this->id_eliminar_seccion)
        ->update([
        'estado'=>0,
        'user_update'=>auth()->user()->id]);

        $this->reset(['nombre_seccion','titulo_seccion','btn_seccion','id_seccion','id_eliminar_seccion']);
        $this->emit('render');
        $this->emit('alertOK','Se elimino la sección con exito.');
    }

    public function limpiar_seccion(){
        $this->reset(['nombre_seccion','titulo_seccion','btn_seccion','id_seccion','id_eliminar_seccion']);
        $this->emit('render');
    }

    public function updatingSearchid(){
        $this->resetPage();
    }

    public function updatingSearchdescripcion(){
        $this->resetPage();
    }

    public function updatingSearchname(){
        $this->resetPage();
    }

    public function updatingSearchfecha(){
        $this->resetPage();
    }

    public function updatingSearchlocal(){
        $this->resetPage();
    }

    public function updatingSearchidseccion(){
        $this->resetPage();
    }

    public function updatingSearchdescripcionseccion(){
        $this->resetPage();
    }

    public function updatingSearchnameseccion(){
        $this->resetPage();
    }

    public function updatingSearchfechaseccion(){
        $this->resetPage();
    }


}
