<?php

namespace App\Http\Livewire;

use Gloudemans\Shoppingcart\Facades\Cart;
use App\Models\product;
use App\Models\setting;
use App\Models\type_tax_Product;
use App\Models\unit_measure;
use Carbon\Carbon;
use Livewire\Component;

class Autocompletewire extends Component
{
    public $addproduct;
    public $result = [];
    public $cantidad_carrito = [];
    public $precio_carrito = [];
    public $total_precio_unit;
    public $impuesto_carrito = [];
    public $gravadas;
    public $inafectos;
    public $exonerados;
    public $igv_carrito;
    public $unit_carrito = [];

    public function mount(){
        $carrito=Cart::content();
        $this->reset(['addproduct','result']);
        Cart::setGlobalTax(0);
        $this->total_precio_unit=0;
        $this->gravadas=0;
        $this->inafectos=0;
        $this->exonerados=0;
        foreach($carrito as $cart){
            $this->cantidad_carrito[$cart->rowId]=$cart->qty;
            $this->total_precio_unit=$this->total_precio_unit+$cart->price;
            $this->precio_carrito[$cart->rowId]=$cart->price;
            $this->impuesto_carrito[$cart->rowId]=$cart->options->tipo_impuesto;
            $this->unit_carrito[$cart->rowId]=$cart->options->tipo_unidad;

            if($cart->options->tipo_impuesto == 1){
                $this->gravadas=$this->gravadas + ($cart->price * $cart->qty);
            }
            if($cart->options->tipo_impuesto == 2){
                $this->inafectos=$this->inafectos + ($cart->price * $cart->qty);
            }
            if($cart->options->tipo_impuesto == 3){
                $this->exonerados=$this->exonerados + ($cart->price * $cart->qty);
            }
        }
        
        $setting = setting::
        select('igv')
        ->get();

        foreach($setting as $rowSetting){
            $this->igv_carrito = $rowSetting->igv;
        }
        
    }

    public function updatedAddproduct(){
        if($this->addproduct != ''){

            $product = product::
            select('id','nombre AS name')
            ->where('nombre', 'like', '%'.trim($this->addproduct).'%')
            ->where('estado', 1)
            ->limit(2);

            $this->result = product::
            select('id','codigo AS name')
            ->where('codigo', 'like', '%'.trim($this->addproduct).'%')
            ->where('estado', 1)
            ->union($product)
            ->limit(4)
            ->get();

        }else{
            $this->result = [];
        }
    }

    public function select_autocomplete($id){
        Cart::setGlobalTax(0);
        //$this->addproduct =$name;
        $product = product::
        select('id','codigo', 'nombre', 'precio', 'id_type_tax_product', 'id_unit_measure')
        ->where('id', $id)
        ->get();

        foreach($product as $producto){
            $product_id = $producto->id;
            $nombre = $producto->nombre;
            $codigo = $producto->codigo;
            $precio = $producto->precio;
            $id_type_tax_product = $producto->id_type_tax_product;
            $id_unit_measure = $producto->id_unit_measure;
            $quantity = 1;
        }

        Cart::add(
            $product_id,
            $nombre, 
            $quantity, 
            $precio,
            '0.0',
            array(
            'codigo' => $codigo,
            'tipo_impuesto' => $id_type_tax_product,
            'tipo_unidad' =>  $id_unit_measure
            )
        );

        $carrito=Cart::content();
        $this->total_precio_unit=0;
        foreach($carrito as $cart){
            $this->cantidad_carrito[$cart->rowId]=$cart->qty;
            $this->precio_carrito[$cart->rowId]=$cart->price;
            $this->total_precio_unit=$this->total_precio_unit+$cart->price;
            $this->impuesto_carrito[$cart->rowId]=$cart->options->tipo_impuesto;
            $this->unit_carrito[$cart->rowId]=$cart->options->tipo_unidad;
        }

        $this->reset(['addproduct','result']);
        $this->emit('render');

        //dd(Cart::content());
    }

    public function add_car(){
        Cart::setGlobalTax(0);
        //$this->addproduct =$name;
        $product = product::
        select('id','codigo', 'nombre', 'precio', 'id_type_tax_product', 'id_unit_measure')
        ->where('estado', 1)
        ->where('nombre', trim($this->addproduct))
        ->Orwhere('codigo', trim($this->addproduct))
        ->limit(1)
        ->get();
        $valid=0;

        foreach($product as $producto){
            $valid=1;
            $product_id = $producto->id;
            $nombre = $producto->nombre;
            $codigo = $producto->codigo;
            $precio = $producto->precio;
            $id_type_tax_product = $producto->id_type_tax_product;
            $id_unit_measure = $producto->id_unit_measure;
            $quantity = 1;
        }

        if($valid===0){
            $product_id=rand() .'_'.date('Y-m-d H:i:s');
            $product_id=str_replace('-','_',$product_id);
            $product_id=str_replace(' ','_',$product_id);
            $product_id=str_replace(':','_',$product_id);
            $nombre = trim($this->addproduct);
            $codigo = '-';
            $precio = 0;
            $id_type_tax_product = 1;
            $id_unit_measure = 1;
            $quantity = 1;
        }

        Cart::add(
            $product_id,
            $nombre, 
            $quantity, 
            $precio,
            '0.0',
            array(
            'codigo' => $codigo,
            'tipo_impuesto' => $id_type_tax_product,
            'tipo_unidad' =>  $id_unit_measure
            )
        );

        $carrito=Cart::content();
        $this->total_precio_unit=0;
        foreach($carrito as $cart){
            $this->cantidad_carrito[$cart->rowId]=$cart->qty;
            $this->precio_carrito[$cart->rowId]=$cart->price;
            $this->total_precio_unit=$this->total_precio_unit+$cart->price;
            $this->impuesto_carrito[$cart->rowId]=$cart->options->tipo_impuesto;
            $this->unit_carrito[$cart->rowId]=$cart->options->tipo_unidad;
        }

        $this->reset(['addproduct','result']);
        $this->emit('render');
    }

    public function deleted_cart($rowId){
        Cart::remove($rowId);
        $carrito=Cart::content();
        $this->total_precio_unit=0;

        foreach($carrito as $cart){
            $this->total_precio_unit=$this->total_precio_unit+$cart->price;
        }
    }

    public function render()
    {
        $datosSistem['type_tax_Product'] = type_tax_Product::
        select('id','name as descripcion')
        ->where('estado', 1)
        ->orderBy('id','asc')
        ->get();

        $datosSistem['unit_measure'] = unit_measure::
        select('id','descripcion')
        ->where('estado', 1)
        ->orderBy('id','asc')
        ->get();

        $datosSistem['carrito']=Cart::content();

        $carrito_tax=Cart::content();
        $this->total_precio_unit=0;
        $this->gravadas=0;
        $this->inafectos=0;
        $this->exonerados=0;
        foreach($carrito_tax as $cart){
            $this->total_precio_unit=$this->total_precio_unit+$cart->price;

            if($cart->options->tipo_impuesto == 1){
                $this->gravadas=$this->gravadas + ($cart->price * $cart->qty);
            }
            if($cart->options->tipo_impuesto == 2){
                $this->inafectos=$this->inafectos + ($cart->price * $cart->qty);
            }
            if($cart->options->tipo_impuesto == 3){
                $this->exonerados=$this->exonerados + ($cart->price * $cart->qty);
            }
        }

        $setting = setting::
        select('igv')
        ->get();

        foreach($setting as $rowSetting){
            $this->igv_carrito = $rowSetting->igv;
        }

        return view('livewire.autocompletewire', compact('datosSistem'));
    }

    public function edit_cant_cart($rowId){
        Cart::update($rowId, $this->cantidad_carrito[$rowId]);
        $carrito=Cart::content();
        $this->total_precio_unit=0;
        foreach($carrito as $cart){
            $this->total_precio_unit=$this->total_precio_unit+$cart->price;
        }
        $this->reset(['addproduct','result']);
        $this->emit('render');
    }

    public function edit_precio_cart($rowId){
        Cart::update($rowId, ['price' => $this->precio_carrito[$rowId]]);
        $carrito=Cart::content();
        $this->total_precio_unit=0;
        foreach($carrito as $cart){
            $this->total_precio_unit=$this->total_precio_unit+$cart->price;
        }
        $this->reset(['addproduct','result']);
        $this->emit('render');
    }

    public function edit_impuesto_cart($rowId){
        $carrito=Cart::content();
        $options=array(
            'codigo' => $carrito[$rowId]->options->codigo,
            'tipo_impuesto' => $this->impuesto_carrito[$rowId],
            'tipo_unidad' =>  $carrito[$rowId]->options->tipo_unidad,
        );
        Cart::update($rowId, ['options'  =>$options]);
        $content=Cart::content();
        #$this->total_precio_unit=0;
        foreach($content as $cart){
            $this->cantidad_carrito[$cart->rowId]=$cart->qty;
            $this->precio_carrito[$cart->rowId]=$cart->price;
            #$this->total_precio_unit=$this->total_precio_unit+$cart->price;
            $this->impuesto_carrito[$cart->rowId]=$cart->options->tipo_impuesto;
            $this->unit_carrito[$cart->rowId]=$cart->options->tipo_unidad;
        }
        $this->reset(['addproduct','result']);
        $this->emit('render');
    }

    public function edit_unit_cart($rowId){
        $carrito=Cart::content();
        $options=array(
            'codigo' => $carrito[$rowId]->options->codigo,
            'tipo_impuesto' => $carrito[$rowId]->options->tipo_impuesto,
            'tipo_unidad' =>  $this->unit_carrito[$rowId],
        );
        Cart::update($rowId, ['options'  =>$options]);
        $content=Cart::content();
        #$this->total_precio_unit=0;
        foreach($content as $cart){
            $this->cantidad_carrito[$cart->rowId]=$cart->qty;
            $this->precio_carrito[$cart->rowId]=$cart->price;
            #$this->total_precio_unit=$this->total_precio_unit+$cart->price;
            $this->impuesto_carrito[$cart->rowId]=$cart->options->tipo_impuesto;
            $this->unit_carrito[$cart->rowId]=$cart->options->tipo_unidad;
        }
        $this->reset(['addproduct','result']);
        $this->emit('render');
    }
}
