<?php

namespace App\Http\Livewire;

use App\Imports\ProductsImport;
use Maatwebsite\Excel\Facades\Excel;
use Livewire\Component;
use Livewire\WithFileUploads;

class CargaMasivaProductwire extends Component
{
    use WithFileUploads;
    public $excelImport;

    protected $rules=[
        "excelImport"=>"required|file"
    ];

    protected $messages = [
        'excelImport.required' => 'no se a cargar ningun archivo.',
        'excelImport.file' => 'se debe cargar un excel.',
    ];
    
    public function render()
    {
        return view('livewire.carga-masiva-productwire');
    }

    public function saveExcel(){

        $this->validate();
        //$this->excelImport->storeAs('excel_masivo_product', 'cargarMasiva');

        Excel::import(new ProductsImport, $this->excelImport);
        $this->reset(['excelImport']);
        $this->emit('cargarListProductos');
        $this->emit('cerrarModalImport');
        $this->emit('alertOK','Se modifico el producto con exito.');
    }

}
