<?php

namespace App\Http\Livewire;

use App\Models\habitacion_aula_mesa;
use App\Models\local;
use App\Models\setting;
use Livewire\Component;
use Livewire\WithPagination;

class Habmesaaulawire extends Component
{
    use WithPagination;
    protected $paginationTheme = 'bootstrap';

    public $searchId;
    public $search_descripcion;
    public $search_name;
    public $search_fecha;
    public $search_local;

    public $descripcion;
    public $id_local=1;

    public $titulo;
    public $btn='Registrar';
    public $tipo_tituloMinus;
    public $tipo_tituloMayus;
    public $tipo_unitario;

    public $id_eliminar;
    public $id_habit_mesa_aula=0;

    protected $listeners=['render'=>'render'];

    protected $rules=[
        "descripcion"=>"required"
    ];

    protected $messages = [
        'descripcion.required' => 'se debe ingresar un nombre.'
    ];

    public function mount(){
        $setting = setting::
        select('id_type_business')
        ->get();

        $tipo_negocio=0;
        foreach($setting as $rowSetting){
            $tipo_negocio = $rowSetting->id_type_business;
        }

        if($tipo_negocio==3){
            $this->titulo='Agregar Mesa';
            $this->tipo_tituloMinus='Mesas';
            $this->tipo_tituloMayus='MESAS';
            $this->tipo_unitario='Mesa';
        }
        if($tipo_negocio==4){
            $this->titulo='Agregar Cuarto';
            $this->tipo_tituloMinus='Cuartos';
            $this->tipo_tituloMayus='CUARTOS';
            $this->tipo_unitario='Cuarto';
        }
    }

    public function render()
    {
        $datosSistem['habitacion_aula_mesa'] = habitacion_aula_mesa::
        select('habitacion_aula_mesa.id','habitacion_aula_mesa.name as descripcion','local.nombre','users.name', 'habitacion_aula_mesa.updated_at')
        ->join('users', 'users.id', '=', 'habitacion_aula_mesa.user_update' )
        ->join('local', 'local.id', '=', 'habitacion_aula_mesa.id_local' )
        ->where('habitacion_aula_mesa.id','like', '%'.$this->searchId.'%')
        ->where('habitacion_aula_mesa.name','like', '%'.$this->search_descripcion.'%')
        ->where('users.name','like', '%'.$this->search_name.'%')
        ->where('habitacion_aula_mesa.updated_at','like', '%'.$this->search_fecha.'%')
        ->where('local.nombre','like', '%'.$this->search_local.'%')
        ->where('habitacion_aula_mesa.estado', 1)
        ->orderBy('habitacion_aula_mesa.id','desc')
        ->paginate(10);

        $datosSistem['local'] = local::
        select('id','nombre')
        ->where('estado', 1)
        ->orderBy('id','asc')
        ->get();

        return view('livewire.habmesaaulawire', compact('datosSistem'));
    }

    public function save(){

        $this->validate();

        if($this->id_habit_mesa_aula==0){
            $identificador_alumno = habitacion_aula_mesa::
            select('id')
            ->where('name', trim($this->descripcion))
            ->where('id_local', $this->id_local)
            ->where('estado',1)
            ->get();
    
            $validExist=0;
            foreach($identificador_alumno as $row){
                $validExist++;
            }

            $setting = setting::
            select('id_type_business')
            ->get();

            $tipo_negocio=0;
            foreach($setting as $rowSetting){
                $tipo_negocio = $rowSetting->id_type_business;
            }

            if($tipo_negocio==3){
                $nomDefault='Mesa';
            }
            if($tipo_negocio==4){
                $nomDefault='Habitación';
            }

            if($validExist==0){
                habitacion_aula_mesa::create([
                    'name'=>trim($this->descripcion),
                    'id_local'=>$this->id_local,
                    'estado'=>1,
                    'user_create'=>auth()->user()->id,
                    'user_update'=>auth()->user()->id
                ]);

                if($tipo_negocio==3){
                    $this->titulo='Agregar Mesa';
                }
                if($tipo_negocio==4){
                    $this->titulo='Agregar Habitación';
                }

                $this->reset(['descripcion','id_local','btn','id_eliminar','id_habit_mesa_aula']);
                $this->emit('render');
                $this->emit('alertOK','Se registro la '.$nomDefault.' con exito.');
            }else{
                $this->emit('alertError','El nombre de la '.$nomDefault.' fue utilizado anteriormente.');
            }
            
        }else{

            $identificador_alumno = habitacion_aula_mesa::
            select('id')
            ->where('name', trim($this->descripcion))
            ->where('id_local', $this->id_local)
            ->where('estado',1)
            ->where('id','!=',$this->id_habit_mesa_aula)
            ->get();
    
            $validExist=0;
            foreach($identificador_alumno as $row){
                $validExist++;
            }

            $setting = setting::
            select('id_type_business')
            ->get();

            $tipo_negocio=0;
            foreach($setting as $rowSetting){
                $tipo_negocio = $rowSetting->id_type_business;
            }

            if($tipo_negocio==3){
                $nomDefault='Mesa';
            }
            if($tipo_negocio==4){
                $nomDefault='Habitación';
            }

            if($validExist==0){
                habitacion_aula_mesa::where('id',$this->id_habit_mesa_aula)
                ->update([
                    'name'=>trim($this->descripcion),
                    'id_local'=>$this->id_local,
                    'user_update'=>auth()->user()->id
                ]);

                if($tipo_negocio==3){
                    $this->titulo='Agregar Mesa';
                }
                if($tipo_negocio==4){
                    $this->titulo='Agregar Habitación';
                }

                $this->reset(['descripcion','id_local','btn','id_eliminar','id_habit_mesa_aula']);
                $this->emit('render');
                $this->emit('alertOK','Se modifico la '.$nomDefault.' con exito.');
            }else{
                $this->emit('alertError','El nombre de la '.$nomDefault.' fue utilizado anteriormente.');
            }

        }
    }

    public function modificarID($id){
        $this->id_habit_mesa_aula=$id;

        $habitacion_aula_mesa = habitacion_aula_mesa::
        select('name','id_local')
        ->where('id', $id)
        ->get();

        foreach($habitacion_aula_mesa as $row){
            $this->descripcion=$row->name;
            $this->id_local=$row->id_local;
        }

        $setting = setting::
        select('id_type_business')
        ->get();

        $tipo_negocio=0;
        foreach($setting as $rowSetting){
            $tipo_negocio = $rowSetting->id_type_business;
        }

        if($tipo_negocio==3){
            $this->titulo='Editar Mesa N° '. $id;
        }
        if($tipo_negocio==4){
            $this->titulo='Editar Habitación N° '. $id;
        }

        $this->btn='Editar';

    }

    public function eliminarID($id){
        $this->id_eliminar=$id;
    }

    public function delete_customer(){
        habitacion_aula_mesa::where('id',$this->id_eliminar)
        ->update([
        'estado'=>0,
        'user_update'=>auth()->user()->id]);

        $setting = setting::
        select('id_type_business')
        ->get();

        $tipo_negocio=0;
        foreach($setting as $rowSetting){
            $tipo_negocio = $rowSetting->id_type_business;
        }

        if($tipo_negocio==3){
            $this->titulo='Agregar Mesa ';
            $nomDefault='Mesa';
        }
        if($tipo_negocio==4){
            $this->titulo='Agregar Habitación ';
            $nomDefault='Habitación';
        }

        $this->reset(['descripcion','id_local','btn','id_eliminar','id_habit_mesa_aula']);
        $this->emit('render');
        $this->emit('alertOK','Se elimino la '.$nomDefault.' con exito.');
    }

    public function limpiar(){
        $setting = setting::
        select('id_type_business')
        ->get();

        $tipo_negocio=0;
        foreach($setting as $rowSetting){
            $tipo_negocio = $rowSetting->id_type_business;
        }

        if($tipo_negocio==3){
            $this->titulo='Agregar Mesa ';
        }
        if($tipo_negocio==4){
            $this->titulo='Agregar Habitación ';
        }

        $this->reset(['descripcion','id_local','btn','id_eliminar','id_habit_mesa_aula']);
        $this->emit('render');
    }

    public function updatingSearchid(){
        $this->resetPage();
    }

    public function updatingSearchdescripcion(){
        $this->resetPage();
    }

    public function updatingSearchname(){
        $this->resetPage();
    }

    public function updatingSearchfecha(){
        $this->resetPage();
    }

    public function updatingSearchlocal(){
        $this->resetPage();
    }

}
