<?php

namespace App\Http\Livewire;

use App\Models\customer_habaulmes;
use Livewire\Component;

class Matriculaulasecwire extends Component
{
    public $pid;
    public $id_eliminar;
    public $year;
    protected $listeners=[  'cargarMatriAlum'=>'render',
                            'delete_matricula'=>'delete_matricula'];

    public function render()
    {
        $id_aula=substr($this->pid,0,strpos($this->pid,'_'));
        $id_seccion=substr($this->pid,strpos($this->pid,'_')+1,strpos($this->pid,'_',strpos($this->pid,'_')));
        $this->year=substr($this->pid,strpos($this->pid,'_',strpos($this->pid,'_')+1)+1);
        
        $datosSistem['customer_habaulmes'] = customer_habaulmes::
        select('identificador_alumno.id as idAlumno','identificador_alumno.name', 'identificador_alumno.dni', 'customer_habaulmes.id as idMatri')
        ->join('identificador_alumno', 'identificador_alumno.id', '=', 'customer_habaulmes.id_identificador_alumno' )
        ->where('id_aulaHM', $id_aula)
        ->where('id_section', ($id_seccion==='_' ? NULL : $id_seccion))
        ->where('identificador_alumno.estado', 1)
        ->where('customer_habaulmes.estado', 1)
        ->whereYear('date_inicial', $this->year)
        ->orderBy('identificador_alumno.id','asc')
        ->get();
        
        return view('livewire.matriculaulasecwire', compact('datosSistem'));
    }

    public function eliminarID_matricula($id){
        $this->emit('eliminar_matricula_js',$id);
    }

    public function delete_matricula($id){
        customer_habaulmes::where('id',$id)
        ->update([
        'estado'=>0,
        'user_update'=>auth()->user()->id]);

        $this->emit('render');
        $this->emit('alertOK','Se elimino el Aula con exito.');
    }
}
