<?php

namespace App\Http\Livewire;

use App\Models\customer_habaulmes;
use App\Models\habitacion_aula_mesa;
use App\Models\identificador_alumno;
use Livewire\Component;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;

class Matriwire extends Component
{
    public $aulaMatricula=0;
    public $seccionMatricula=0;
    public $id_identificador_alumno;
    public $year_search='';

    public function mount(Request $request)
    {
        $datosSistem['year'] = customer_habaulmes::
        select(DB::raw("DISTINCT DATE_FORMAT(customer_habaulmes.date_inicial, '%Y') as year_inicial"))
        ->join('habitacion_aula_mesa', 'habitacion_aula_mesa.id', '=', 'customer_habaulmes.id_aulaHM' )
        ->where('customer_habaulmes.estado', 1)
        ->where('customer_habaulmes.id_identificador_alumno','!=', NULL)
        ->where('habitacion_aula_mesa.id_local', $request->session()->get('local'))
        ->orderBy('customer_habaulmes.date_inicial','desc')
        ->get();

        $count_inicial=0;
        if(json_encode($datosSistem['year']) !== '[]'){
            foreach($datosSistem['year'] as $year){
                if($count_inicial==0){
                    $this->year_search = $year->year_inicial;
                }
                $count_inicial++;
            }
        }else{
            $this->year_search = date("Y");
        }
        
    }

    public function render(Request $request)
    {
        $datosSistem['identificador_alumno'] = identificador_alumno::
        select(DB::raw("DISTINCT identificador_alumno.id, identificador_alumno.name,identificador_alumno.dni"))
        ->leftJoin('customer_habaulmes', 'customer_habaulmes.id_identificador_alumno', '=', 'identificador_alumno.id' )
        ->where('identificador_alumno.estado', 1)
        ->where('customer_habaulmes.estado', null)
        ->Orwhere('customer_habaulmes.estado', 0)
        ->Orwhere(DB::raw("DATE_FORMAT(customer_habaulmes.date_inicial, '%Y')"), '!=', date("Y"))
        ->orderBy('identificador_alumno.id','asc')
        ->get();
        
        $datosSistem['habitacion_aula_mesa'] = habitacion_aula_mesa::
        select('name as nameAula','habitacion_aula_mesa.id as aulaID','section.id as seccionID', 'descripcion as nameSeccion')
        ->join('local as localHAM', 'localHAM.id', '=', 'habitacion_aula_mesa.id_local' )
        ->leftJoin('section', 'section.id_aulaHM', '=', 'habitacion_aula_mesa.id' )
        //->leftJoin('customer_habaulmes as cus_habaulmes', 'cus_habaulmes.id_aulaHM', '=', 'habitacion_aula_mesa.id' )
        ->where('localHAM.id', $request->session()->get('local'))
        ->where('habitacion_aula_mesa.estado', 1)
        ->orderBy('habitacion_aula_mesa.id','desc')
        ->distinct()
        ->get();

        $datosSistem['year'] = customer_habaulmes::
        select(DB::raw("DISTINCT DATE_FORMAT(customer_habaulmes.date_inicial, '%Y') as year_inicial"))
        ->join('habitacion_aula_mesa', 'habitacion_aula_mesa.id', '=', 'customer_habaulmes.id_aulaHM' )
        ->where('customer_habaulmes.estado', 1)
        ->where('customer_habaulmes.id_identificador_alumno','!=', NULL)
        ->where('habitacion_aula_mesa.id_local', $request->session()->get('local'))
        ->where(DB::raw("DATE_FORMAT(customer_habaulmes.date_inicial, '%Y')"), '!=', date("Y"))
        ->orderBy('customer_habaulmes.date_inicial','asc')
        ->get();
        
        return view('livewire.matriwire', compact('datosSistem'));
    }

    public function agregarMatricula($idAula, $idSeccion=NULL){
        $this->aulaMatricula = $idAula;
        $this->seccionMatricula = $idSeccion;
    }

    public function CrearMatriAlumno(){
        customer_habaulmes::create([
            //'id_customer' => $this->id_customer_cuenta,
            'id_identificador_alumno' => $this->id_identificador_alumno,
            'id_aulaHM' => $this->aulaMatricula,
            'id_section' => $this->seccionMatricula,
            'date_inicial' => date('Y-m-d H:i:s'),
            'user_create'=>auth()->user()->id,
            'user_update'=>auth()->user()->id,
            'estado' => 1
        ]);
        $this->reset(['id_identificador_alumno','aulaMatricula', 'seccionMatricula']);
        $this->emit('cargarMatriAlum');
    }

    public function render_cargarMatriAlum(){
        $this->emit('cargarMatriAlum');
    }
}
