<?php

namespace App\Http\Livewire;

use App\Models\role_has_permissions;
use Livewire\Component;
use Livewire\WithPagination;
use Spatie\Permission\Models\Permission;
use Spatie\Permission\Models\Role;

class Permisoswire extends Component
{
    use WithPagination;
    protected $paginationTheme = 'bootstrap';

    public $titulo="Registrar Perfil";
    public $btn="Registrar";

    public $id_eliminar;
    public $id_rol=0;

    public $searchId;
    public $search_name;

    public $namePerfil;
    public $permisosRol=[];

    protected $rules=[
        "namePerfil"=>"required",
        //"permisosRol"=>"required",
    ];

    protected $messages = [
        'namePerfil.required' => 'se debe ingresar un nombre.',
        //'permisosRol.required' => 'se debe seleccionar por lo menos un permiso.',
    ];

    public function render()
    {
        $datosSistem['roles']=Role::
        select('id','name')
        ->where('roles.id','like', '%'.$this->searchId.'%')
        ->where('roles.name','like', '%'.$this->search_name.'%')
        ->orderBy('roles.id','desc')
        ->paginate(10);

        $datosSistem['permisos']=Permission::
        select('id','name','descripcion')
        ->get();

        return view('livewire.permisoswire', compact('datosSistem'));
    }

    public function save(){

        $this->validate();

        $validPermisosRol=0;
        if($this->permisosRol != null){
            $validPermisosRol=1;
        }

        if($validPermisosRol>0){
            if($this->id_rol==0){

                $productovalid01 = Role::
                select('id')
                ->where('name', trim($this->namePerfil))
                ->where('id','<>', $this->id_rol)
                ->get();
                        
                $validRol=0;
                foreach($productovalid01 as $row){
                    $validRol++;
                }

                if($validRol==0){
                    $rol = Role::create(['name'=>trim($this->namePerfil)]);
                    $rol->permissions()->sync($this->permisosRol);
        
                    $this->reset(['permisosRol','namePerfil','id_rol','titulo','btn','id_eliminar']);
                    $this->emit('render');
                    $this->emit('alertOK','Se registro el perfil con exito.');
                }else{
                    $this->emit('alertError','el nombre de este permiso ya fue utilizado.');
                }
                
            }else{

                $productovalid01 = Role::
                select('id')
                ->where('name', trim($this->namePerfil))
                ->where('id','<>', $this->id_rol)
                ->get();
                        
                $validRol=0;
                foreach($productovalid01 as $row){
                    $validRol++;
                }

                if($validRol==0){
                    $role = Role::find($this->id_rol);
                    $role->name = trim($this->namePerfil);
                    $role->save();
                    
                    $role->permissions()->sync($this->permisosRol);
                
                    /*$rol = Role::where('id',$this->id_rol)
                    ->update(['name'=>$this->namePerfil]);
                    $rol->permissions()->sync($this->permisosRol);*/
        
                    $this->reset(['permisosRol','namePerfil','id_rol','titulo','btn','id_eliminar']);
                    $this->emit('render');
                    $this->emit('alertOK','Se modifico el perfil con exito.');
                }else{
                    $this->emit('alertError','el nombre de este permiso ya fue utilizado.');
                }

            }
        }else{
            $this->emit('alertError','Se debe seleccionar por lo menos un permiso.');
        }

    }

    public function modificarID($id){
        $this->id_rol=$id;

        $Role = Role::
        select('id','name')
        ->where('id', $id)
        ->get();

        foreach($Role as $row){
            $this->namePerfil=$row->name;
        }

        $role_has_permissions = role_has_permissions::select('permission_id')
        ->where('role_id',$id)
        ->get();

        foreach($role_has_permissions as $rowP){
            $dataPermisos[]=(String)$rowP->permission_id;
        }

        $this->permisosRol = $dataPermisos;

        $this->titulo='Editar Perfil N° '. $id;
        $this->btn='Editar';
    }

    public function eliminarID($id){
        $this->id_eliminar=$id;
    }

    public function delete_categoria(){

        $role = Role::find($this->id_eliminar);
        $role->delete();

        $this->reset(['permisosRol','namePerfil','id_rol','titulo','btn','id_eliminar']);
        $this->emit('render');
        $this->emit('alertOK','Se elimino la categoria con exito.');
    }

    public function limpiar(){
        $this->reset(['permisosRol','namePerfil','id_rol','titulo','btn','id_eliminar']);
        $this->emit('render');
    }

    public function updatingSearchid(){
        $this->resetPage();
    }

    public function updatingSearchname(){
        $this->resetPage();
    }

}
