<?php

namespace App\Http\Livewire;

use App\Models\category;
use App\Models\currency;
use App\Models\mark;
use App\Models\product;
use App\Models\type_tax_Product;
use App\Models\unit_measure;
use Illuminate\Support\Facades\DB;
use Carbon\Carbon;
use Livewire\Component;
use Livewire\WithPagination;

class Productwire extends Component
{
    use WithPagination;
    protected $paginationTheme = 'bootstrap';
    
    public $searchId;
    public $search_codigo;
    public $search_nombre;
    public $search_categoria;
    public $search_marca;
    public $search_moneda;
    public $search_impuesto;
    public $search_Pcompra;
    public $search_Pventa;
    public $search_alertaStock;
    /*public $search_name;
    public $search_fecha;*/
    public $search_unidades;
    //public $search_stock;

    public $categoria=1;
    public $marca=1;
    public $codigo;
    public $descripcion;
    public $moneda=1;
    public $id_impuesto=1;
    public $compra;
    public $venta;
    public $alert_stock;
    public $id_unidades=1;

    public $titulo='Agregar Producto';
    public $btn='REGISTRAR';

    public $id_eliminar;
    public $id_product=0;

    protected $listeners=['cargarListProductos'=>'render'];

    protected $rules=[
        "descripcion"=>"required",
        "compra"=>"required",
        "venta"=>"required",
        "alert_stock"=>"required"
    ];

    protected $messages = [
        'descripcion.required' => 'se debe ingresar un nombre para la categoría.',
        'compra.required' => 'se debe ingresar el precio de compra.',
        'venta.required' => 'se debe ingresar el precio de venta.',
        'alert_stock.required' => 'se debe ingresar el stock minimo antes de enviar la alerta de producto faltante.',
    ];

    public function render()
    {
        if($this->search_codigo == null || $this->search_codigo == ''){
            $datosSistem['producto'] = product::
            /*select('product.id','product.codigo','product.nombre','category.name as nameCategoria','mark.name as nameMarca','type_tax_product.name as nameImpuesto',
            'product.costo','product.precio','product.alerta_stock','users.name', 'product.updated_at', 'currency.descripcion as nameMoneda')*/
            selectRaw('product.id,product.codigo,product.nombre,category.name as nameCategoria,mark.name as nameMarca,type_tax_product.name as nameImpuesto,
            product.costo,product.precio,product.alerta_stock, currency.descripcion as nameMoneda, unit_measure.descripcion as unidades, sum(stock) as cantProd')
            ->join('users', 'users.id', '=', 'product.user_update' )
            ->leftJoin('category', 'category.id', '=', 'product.id_categoria' )
            ->leftJoin('mark', 'mark.id', '=', 'product.id_marca' )
            ->leftJoin('type_tax_product', 'type_tax_product.id', '=', 'product.id_type_tax_product' )
            ->leftJoin('currency', 'currency.id', '=', 'product.id_currency' )
            ->leftJoin('unit_measure', 'unit_measure.id', '=', 'product.id_unit_measure' )
            ->leftJoin('warehouses_stock', 'warehouses_stock.id_product', '=', 'product.id' )
            ->where('product.id','like', '%'.$this->searchId.'%')
            ->where('product.nombre','like', '%'.$this->search_nombre.'%')
            ->where('category.name','like', '%'.$this->search_categoria.'%')
            ->where('mark.name','like', '%'.$this->search_marca.'%')
            ->where('currency.descripcion','like', '%'.$this->search_moneda.'%')
            ->where('type_tax_product.name','like', '%'.$this->search_impuesto.'%')
            ->where('product.costo','like', '%'.$this->search_Pcompra.'%')
            ->where('product.precio','like', '%'.$this->search_Pventa.'%')
            ->where('product.alerta_stock','like', '%'.$this->search_alertaStock.'%')
            //->where('users.name','like', '%'.$this->search_name.'%')
            //->where('product.updated_at','like', '%'.$this->search_fecha.'%')
            ->where('unit_measure.descripcion','like', '%'.$this->search_unidades.'%')
            //->where('cantProd','like', '%'.$this->search_stock.'%')
            ->groupBy('product.id')
            ->where('product.estado', 1)
            ->orderBy('product.id','desc')
            ->paginate(10);
        }else{
            $datosSistem['producto'] = product::
            /*select('product.id','product.codigo','product.nombre','category.name as nameCategoria','mark.name as nameMarca','type_tax_product.name as nameImpuesto',
            'product.costo','product.precio','product.alerta_stock','users.name', 'product.updated_at', 'currency.descripcion as nameMoneda')*/
            selectRaw('product.id,product.codigo,product.nombre,category.name as nameCategoria,mark.name as nameMarca,type_tax_product.name as nameImpuesto,
            product.costo,product.precio,product.alerta_stock, currency.descripcion as nameMoneda, unit_measure.descripcion as unidades, sum(stock) as cantProd')
            ->join('users', 'users.id', '=', 'product.user_update' )
            ->leftJoin('category', 'category.id', '=', 'product.id_categoria' )
            ->leftJoin('mark', 'mark.id', '=', 'product.id_marca' )
            ->leftJoin('type_tax_product', 'type_tax_product.id', '=', 'product.id_type_tax_product' )
            ->leftJoin('currency', 'currency.id', '=', 'product.id_currency' )
            ->where('product.id','like', '%'.$this->searchId.'%')
            ->where('product.codigo','like', '%'.$this->search_codigo.'%')
            ->where('product.nombre','like', '%'.$this->search_nombre.'%')
            ->where('category.name','like', '%'.$this->search_categoria.'%')
            ->where('mark.name','like', '%'.$this->search_marca.'%')
            ->where('currency.descripcion','like', '%'.$this->search_moneda.'%')
            ->where('type_tax_product.name','like', '%'.$this->search_impuesto.'%')
            ->where('product.costo','like', '%'.$this->search_Pcompra.'%')
            ->where('product.precio','like', '%'.$this->search_Pventa.'%')
            ->where('product.alerta_stock','like', '%'.$this->search_alertaStock.'%')
            //->where('users.name','like', '%'.$this->search_name.'%')
            //->where('product.updated_at','like', '%'.$this->search_fecha.'%')
            ->where('unit_measure.descripcion','like', '%'.$this->search_unidades.'%')
            //->where('cantProd','like', '%'.$this->search_stock.'%')
            ->where('product.estado', 1)
            ->orderBy('product.id','desc')
            ->paginate(10);
        }

        $datosSistem['category'] = category::
        select('category.id','category.name as descripcion')
        ->where('category.estado', 1)
        ->orderBy('category.id','asc')
        ->get();

        $datosSistem['mark'] = mark::
        select('mark.id','mark.name as descripcion')
        ->where('mark.estado', 1)
        ->orderBy('mark.id','asc')
        ->get();

        $datosSistem['tip_imp'] = type_tax_Product::
        select('id','name as descripcion')
        ->where('estado', 1)
        ->orderBy('id','asc')
        ->get();

        $datosSistem['currency'] = currency::
        select('id','descripcion')
        ->where('estado', 1)
        ->orderBy('id','asc')
        ->get();

        $datosSistem['unit_measure'] = unit_measure::
        select('id','descripcion')
        ->where('estado', 1)
        ->orderBy('id','asc')
        ->get();

        return view('livewire.productwire', compact('datosSistem'));
    }

    public function limpiar(){
        $this->reset(['categoria', 'marca','codigo','descripcion','id_impuesto','compra','venta','alert_stock','titulo','btn','id_eliminar','id_product','moneda','id_unidades']);
    }

    public function save(){

        $this->validate();

        $validNum=0;
        $mensNum='';
        if(!is_numeric(trim($this->compra))){
            $validNum++;
            $mensNum=$mensNum. PHP_EOL .'* Formato incorrecto en el precio de compras';
        }

        if(!is_numeric(trim($this->venta))){
            $validNum++;
            $mensNum=$mensNum. PHP_EOL .'* Formato incorrecto en el precio de venta';
        }

        if(is_numeric(trim($this->alert_stock))){
            if(!is_int(trim($this->alert_stock)*1)){
                $validNum++;
                $mensNum=$mensNum. PHP_EOL .'* La alerta de stock debe ser un número entero';
            }
        }else{
            $validNum++;
            $mensNum=$mensNum. PHP_EOL .'* La alerta de stock debe ser un número entero';
        }

        if($validNum==0){
            if($this->id_product==0){

                $productovalid01 = product::
                select('id')
                ->where('codigo', trim($this->codigo))
                ->where('codigo','!=', '')
                ->get();
                        
                $validCode=0;
                foreach($productovalid01 as $row){
                    $validCode++;
                }
                
                $productovalid02 = product::
                select('id')
                ->where('nombre', trim($this->descripcion))
                ->get();
                        
                $validNombre=0;
                foreach($productovalid02 as $row){
                    $validNombre++;
                }
    
                if($validNombre==0 && $validCode==0){
    
                    $mytime = Carbon::now();
            
                    $fecha_reg=$mytime->toDateTimeString();
    
                    $IDproduct = product::create([
                        'id_categoria'=>$this->categoria,
                        'id_marca'=>$this->marca,
                        'codigo'=>trim($this->codigo),
                        'nombre'=>trim($this->descripcion),
                        'costo'=>$this->compra,
                        'precio'=>$this->venta,
                        'id_unit_measure'=>$this->id_unidades,
                        'id_type_tax_product'=>$this->id_impuesto,
                        'id_currency'=>$this->moneda,
                        'alerta_stock'=>$this->alert_stock,
                        'estado'=>1,
                        'user_create'=>auth()->user()->id,
                        'user_update'=>auth()->user()->id
                    ])->id;
    
                    DB::select('CALL create_stock_product(?,?,?)', 
                        [auth()->user()->id, $fecha_reg, $IDproduct]);
    
                    $this->reset(['categoria', 'marca','codigo','descripcion','id_impuesto','compra','venta','alert_stock','titulo','btn','id_eliminar','id_product','moneda','id_unidades']);
                    $this->emit('cargarListProductos');
                    $this->emit('cerrarModal');
                    $this->emit('alertOK','Se registro el producto con exito.');
    
                }else{
                    if($validNombre!=0 && $validCode!=0){
                        $mensajeError="El codigo y el nombre del producto ya fueron registrados antes";
                    }
                    if($validNombre==0 && $validCode!=0){
                        $mensajeError="El codigo del producto ya fueron registrados antes";
                    }
                    if($validNombre!=0 && $validCode==0){
                        $mensajeError="El nombre del producto ya fueron registrados antes";
                    }
                    $this->emit('alertError',$mensajeError);
                }
    
            }else{
    
                $productovalid01 = product::
                select('id')
                ->where('codigo', trim($this->codigo))
                ->where('id','<>', $this->id_product)
                ->where('codigo','!=', '')
                ->get();
                        
                $validCode=0;
                foreach($productovalid01 as $row){
                    $validCode++;
                }
                
                $productovalid02 = product::
                select('id')
                ->where('nombre', trim($this->descripcion))
                ->where('id','<>', $this->id_product)
                ->get();
                        
                $validNombre=0;
                foreach($productovalid02 as $row){
                    $validNombre++;
                }
    
                if($validNombre==0 && $validCode==0){
    
                    product::where('id',$this->id_product)
                    ->update([
                        'id_categoria'=>$this->categoria,
                        'id_marca'=>$this->marca,
                        'codigo'=>trim($this->codigo),
                        'nombre'=>trim($this->descripcion),
                        'costo'=>$this->compra,
                        'precio'=>$this->venta,
                        'id_unit_measure'=>$this->id_unidades,
                        'id_type_tax_product'=>$this->id_impuesto,
                        'id_currency'=>$this->moneda,
                        'alerta_stock'=>$this->alert_stock,
                        'user_update'=>auth()->user()->id
                    ]);
    
                    $this->reset(['categoria', 'marca','codigo','descripcion','id_impuesto','compra','venta','alert_stock','titulo','btn','id_eliminar','id_product','moneda','id_unidades']);
                    $this->emit('cargarListProductos');
                    $this->emit('cerrarModal');
                    $this->emit('alertOK','Se modifico el producto con exito.');
                    
                }else{
    
                    if($validNombre!=0 && $validCode!=0){
                        $mensajeError="El codigo y el nombre del producto ya fueron registrados antes";
                    }
                    if($validNombre==0 && $validCode!=0){
                        $mensajeError="El codigo del producto ya fueron registrados antes";
                    }
                    if($validNombre!=0 && $validCode==0){
                        $mensajeError="El nombre del producto ya fueron registrados antes";
                    }
                    $this->emit('alertError',$mensajeError);
    
                }
    
            }
        }else{
            $this->emit('alertError','se presentaron los siguientes errores:'. 
            $mensNum);
        }

    }

    public function eliminarID($id){
        $this->id_eliminar=$id;
    }

    public function delete_producto(){
        product::where('id',$this->id_eliminar)
        ->update([
        'estado'=>0,
        'user_update'=>auth()->user()->id]);

        $this->reset(['categoria', 'marca','codigo','descripcion','id_impuesto','compra','venta','alert_stock','titulo','btn','id_eliminar','id_product','moneda','id_unidades']);
        $this->emit('cargarListProductos');
        $this->emit('alertOK','Se elimino el producto con exito.');
    }

    public function modificarID($id){
        $this->id_product=$id;

        $mark = product::
        select('id_categoria','id_marca','codigo','nombre','costo','precio','id_type_tax_product','alerta_stock','id_currency','id_unit_measure')
        ->where('id', $id)
        ->get();

        foreach($mark as $row){
            $this->categoria=(String)$row->id_categoria;
            $this->marca=(String)$row->id_marca;
            $this->moneda=(String)$row->id_currency;
            $this->codigo=$row->codigo;
            $this->descripcion=$row->nombre;
            $this->compra=$row->costo;
            $this->venta=$row->precio;
            $this->id_impuesto=$row->id_type_tax_product;
            $this->alert_stock=$row->alerta_stock;
            $this->id_unidades=(String)$row->id_unit_measure;
        }

        $this->titulo='Editar Producto N° '. $id;
        $this->btn='EDITAR';

    }

    public function updatingSearchid(){
        $this->resetPage();
    }

    public function updatingSearchcodigo(){
        $this->resetPage();
    }

    public function updatingSearchnombre(){
        $this->resetPage();
    }

    public function updatingSearchcategoria(){
        $this->resetPage();
    }

    public function updatingSearchmarca(){
        $this->resetPage();
    }

    public function updatingSearchmoneda(){
        $this->resetPage();
    }

    public function updatingSearchimpuesto(){
        $this->resetPage();
    }

    public function updatingSearchpcompra(){
        $this->resetPage();
    }

    public function updatingSearchpventa(){
        $this->resetPage();
    }

    public function updatingSearchalertastock(){
        $this->resetPage();
    }

    /*public function updatingSearchname(){
        $this->resetPage();
    }

    public function updatingSearchfecha(){
        $this->resetPage();
    }*/

    public function updatingSearchunidades(){
        $this->resetPage();
    }

}
