<?php

namespace App\Http\Livewire;

use App\Models\model_has_roles;
use App\Models\roles;
use App\Models\tipoDocumentoCliente;
use App\Models\User;
use Livewire\Component;
use Livewire\WithPagination;
use Illuminate\Support\Facades\Hash;
use Spatie\Permission\Models\Role;

class Usuarioswire extends Component
{
    use WithPagination;
    protected $paginationTheme = 'bootstrap';

    public $titulo="Registrar Usuario";
    public $btn="Registrar";

    public $searchId;
    public $search_name;
    public $search_email;
    public $search_Rol;
    public $search_fecha;

    public $id_eliminar;
    public $id_user=0;

    public $rolUser;
    public $nameUser;
    public $correoUser;
    public $passUser1;
    public $passUser2;

    protected $rules=[
        "nameUser"=>"required",
        "correoUser"=>"required|email",
        /*"passUser1"=>"required",
        "passUser2"=>"required",*/
    ];

    protected $messages = [
        'nameUser.required' => 'se debe ingresar un nombre.',
        'correoUser.required' => 'se debe ingresar un correo.',
        'correoUser.email' => 'el formato del correo no es correcto.',
    ];

    public function render()
    {
        if($this->search_Rol== null || $this->search_Rol=='' || $this->search_Rol==0){
            $datosSistem['User'] = User::
            select('users.id','users.name','email', 'users.updated_at')
            ->join('model_has_roles', 'model_has_roles.model_id', '=', 'users.id' )
            ->where('users.id','like', '%'.$this->searchId.'%')
            ->where('users.name','like', '%'.$this->search_name.'%')
            ->where('email','like', '%'.$this->search_email.'%')
            ->where('users.updated_at','like', '%'.$this->search_fecha.'%')
            ->where('users.id','!=', '1')
            ->where('users.estado','1')
            ->orderBy('users.id','desc')
            ->with('roles')
            /*->where(['roles' => function($q){
                $q->where('roles.name','like', '%'.$this->search_Rol.'%');
            }])*/
            ->paginate(10);
        }else{
            $datosSistem['User'] = User::
            select('users.id','users.name','email', 'users.updated_at')
            ->join('model_has_roles', 'model_has_roles.model_id', '=', 'users.id' )
            ->where('users.id','like', '%'.$this->searchId.'%')
            ->where('users.name','like', '%'.$this->search_name.'%')
            ->where('email','like', '%'.$this->search_email.'%')
            ->where('users.updated_at','like', '%'.$this->search_fecha.'%')
            ->where('model_has_roles.role_id', $this->search_Rol)
            ->where('users.id','!=', '1')
            ->where('users.estado','1')
            ->orderBy('users.id','desc')
            ->with('roles')
            /*->where(['roles' => function($q){
                $q->where('roles.name','like', '%'.$this->search_Rol.'%');
            }])*/
            ->paginate(10);
        }

        $datosSistem['roles'] = Role::
        select('id','name')
        //->where('estado', 1)
        ->get();


        return view('livewire.usuarioswire', compact('datosSistem'));
    }

    public function save(){
        $this->validate();

        $validaciones=0;
        $mensajeError='';
        if($this->rolUser==0 || is_null($this->rolUser)){
            $mensajeError='Rol de usuario';
            $validaciones++;
        }

        if($this->id_user==0){

            if(strlen($this->passUser1)>7){
                if($this->passUser1 == $this->passUser2){}else{
                    $validaciones++;
                    if(strlen($mensajeError)>0){
                        $mensajeError=$mensajeError.', Con Firmación de Contraseña';
                    }else{
                        $mensajeError='Con Firmación de Contraseña';
                    }
                }
            }else{
                $validaciones++;
                if(strlen($mensajeError)>0){
                    $mensajeError=$mensajeError.', la contraseña debe tener por lo menos 8 caracteres';
                }else{
                    $mensajeError='la contraseña debe tener por lo menos 8 caracteres';
                }
            }

            $mail_User = User::
                select('id')
                ->where('email', trim($this->correoUser))
                ->where('estado', 1)
                ->get();
            foreach($mail_User as $mail_row){
                $validaciones++;
                if($validaciones>0){
                    $mensajeError=$mensajeError.', el correo ya fue registrado anterioremente';
                    $validaciones++;
                }else{
                    $mensajeError='el correo ya fue registrado anterioremente';
                    $validaciones++;
                }
            }
    
            if($validaciones==0){
                User::create([
                    'name'=>trim($this->nameUser),
                    'email'=>trim($this->correoUser),
                    'password'=>Hash::make($this->passUser1),//$this->passUser1,
                    'estado'=>1,
                ])->assignRole($this->rolUser);
                $this->reset(['nameUser','correoUser','rolUser','passUser1','passUser2','id_user','titulo','btn','id_eliminar']);
                $this->emit('render');
                $this->emit('alertOK','Se registro el usuario con exito.');
            }else{
                $this->emit('alertError','Error con : '.$mensajeError);
            }
        }else{
            $mail_User = User::
                select('id')
                ->where('email', trim($this->correoUser))
                ->where('estado', 1)
                ->where('id','!=', $this->id_user)
                ->get();
            foreach($mail_User as $mail_row){
                $validaciones++;
                if($validaciones>0){
                    $mensajeError=$mensajeError.', el correo ya fue registrado anterioremente';
                    $validaciones++;
                }else{
                    $mensajeError='el correo ya fue registrado anterioremente';
                    $validaciones++;
                }
            }

            $validPASSWORD=0;
            if(strlen($this->passUser1)>1){
                $validPASSWORD++;
                if(strlen($this->passUser1)>7){
                    if($this->passUser1 == $this->passUser2){}else{
                        $validaciones++;
                        if(strlen($mensajeError)>0){
                            $mensajeError=$mensajeError.', Con Firmación de Contraseña';
                        }else{
                            $mensajeError='Con Firmación de Contraseña';
                        }
                    }
                }else{
                    $validaciones++;
                    if(strlen($mensajeError)>0){
                        $mensajeError=$mensajeError.', la contraseña debe tener por lo menos 8 caracteres';
                    }else{
                        $mensajeError='la contraseña debe tener por lo menos 8 caracteres';
                    }
                }
            }

            if($validaciones==0){

                if($validPASSWORD==0){
                    User::where('id',$this->id_user)
                    ->update([
                        'name'=>trim($this->nameUser),
                        'email'=>trim($this->correoUser),
                    ]);
                    model_has_roles::where('model_id',$this->id_user)->update([
                        'role_id'=>$this->rolUser,
                    ]);
                }else{

                    User::where('id',$this->id_user)
                    ->update([
                        'name'=>trim($this->nameUser),
                        'email'=>trim($this->correoUser),
                        'password'=>Hash::make($this->passUser1)
                    ]);
                    model_has_roles::where('model_id',$this->id_user)->update([
                        'role_id'=>$this->rolUser,
                    ]);
                }
                $this->reset(['nameUser','correoUser','rolUser','passUser1','passUser2','id_user','titulo','btn','id_eliminar']);
                $this->emit('render');
                $this->emit('alertOK','Se modifico el usuario con exito.');
            }else{
                $this->emit('alertError','Error con : '.$mensajeError);
            }

        }
    }

    public function modificarID($id){
        $this->id_user=$id;

        $Categoria = User::
        select('name', 'email','role_id')
        ->join('model_has_roles', 'model_has_roles.model_id', '=', 'users.id' )
        ->where('id', $id)
        ->get();

        foreach($Categoria as $row){
            $this->nameUser=$row->name;
            $this->correoUser=$row->email;
            $this->rolUser=$row->role_id;
        }

        $this->passUser1='';
        $this->passUser2='';

        $this->titulo='Editar Usuario N° '. $id;
        $this->btn='Editar';

    }

    public function eliminarID($id){
        $this->id_eliminar=$id;
    }

    public function delete_categoria(){
        User::where('id',$this->id_eliminar)
        ->update([
        'estado'=>0]);

        $this->reset(['nameUser','correoUser','rolUser','passUser1','passUser2','id_user','titulo','btn','id_eliminar']);
        $this->emit('render');
        $this->emit('alertCategoria','Se elimino la categoria con exito.');
    }

    public function limpiar(){
        $this->reset(['nameUser','correoUser','rolUser','passUser1','passUser2','id_user','titulo','btn','id_eliminar']);
        $this->emit('render');
    }

    public function updatingSearchid(){
        $this->resetPage();
    }

    public function updatingSearchname(){
        $this->resetPage();
    }

    public function updatingSearchemail(){
        $this->resetPage();
    }

    public function updatingSearchrol(){
        $this->resetPage();
    }

    public function updatingSearchfecha(){
        $this->resetPage();
    }

}
