<?php

namespace App\Imports;

use App\Models\category;
use App\Models\currency;
use App\Models\mark;
use App\Models\product;
use App\Models\type_tax_Product;
use App\Models\unit_measure;
use Illuminate\Support\Facades\DB;
use Carbon\Carbon;
use Maatwebsite\Excel\Concerns\ToModel;

class ProductsImport implements ToModel
{
    /**
    * @param array $row
    *
    * @return \Illuminate\Database\Eloquent\Model|null
    */
    public function model(array $row)
    {
        
        $validCABECERA=0;
        if(strtoupper(trim($row['4']))=='MONEDA' && strtoupper(trim($row['7']))=='IMPUESTO' && strtoupper(trim($row['9']))=='STOCK'){
            $validCABECERA++;
        }

        if(trim($row['3'])==''){
            $validCABECERA++;
        }
        
        if($validCABECERA==0){
            $valid_unit_measure=unit_measure::select('id')
            ->where('descripcion',trim($row['8']))
            ->get();
    
            $id_unidad=1;
            foreach($valid_unit_measure as $rowunit_measure){
                $id_unidad= $rowunit_measure->id;
            }
            $valid_impuesto=type_tax_Product::select('id')
            ->where('name',trim($row['7']))
            ->get();
    
            $id_tax=1;
            foreach($valid_impuesto as $rowTax){
                $id_tax= $rowTax->id;
            }
    
            $valid_moneda=currency::select('id')
            ->where('descripcion',trim($row['4']))
            ->get();
    
            $id_moneda=1;
            foreach($valid_moneda as $rowMoneda){
                $id_moneda= $rowMoneda->id;
            }

            if(trim($row['0'])!=''){
                $valid_categoria=category::select('id')
                ->where('name',trim($row['0']))
                ->get();

                $id_category=0;
                foreach($valid_categoria as $rowcat){
                    $id_category= $rowcat->id;
                }
        
                if($id_category==0){
                    $id_category=category::create([
                        'name'=>trim($row['0']),
                        'id_category_sup'=>0,
                        'estado'=>1,
                        'user_create'=>auth()->user()->id,
                        'user_update'=>auth()->user()->id
                    ])->id;
                }
            }else{
                $id_category=1;
            }
    
            if(trim($row['1'])!=''){
                $valid_marca=mark::select('id')
                ->where('name',trim($row['1']))
                ->get();
        
                $id_marca=0;
                foreach($valid_marca as $rowmarc){
                    $id_marca= $rowmarc->id;
                }
        
                if($id_marca==0){
                    $id_marca=mark::create([
                        'name'=>trim($row['1']),
                        'id_category_sup'=>0,
                        'estado'=>1,
                        'user_create'=>auth()->user()->id,
                        'user_update'=>auth()->user()->id
                    ])->id;
                }
            }else{
                $id_marca=1;
            }
    
            $productovalid01 = product::
            select('id')
            ->where('codigo', trim($row['2']))
            ->where('codigo','!=', '')
            ->where('estado',1)
            ->get();
                    
            $validCode=0;
            foreach($productovalid01 as $rowVV){
                $validCode++;
            }
            
            $productovalid02 = product::
            select('id')
            ->where('nombre', trim($row['3']))
            ->where('estado',1)
            ->get();
                    
            $validNombre=0;
            foreach($productovalid02 as $rowV){
                $validNombre++;
            }
    
            if($validNombre==0 && $validCode==0){
                $mytime = Carbon::now();
            
                $fecha_reg=$mytime->toDateTimeString();
    
                $IDproduct = product::create([
                    'id_categoria'          =>$id_category,
                    'id_marca'              =>$id_marca,
                    'codigo'                =>trim($row['2']),
                    'nombre'                =>trim($row['3']),
                    'id_currency'           =>$id_moneda,
                    'costo'                 =>(double)trim($row['5']),
                    'precio'                =>(double)trim($row['6']),
                    'id_type_tax_product'   =>$id_tax,
                    'id_unit_measure'       =>$id_unidad,
                    'alerta_stock'          =>0,
                    'estado'                =>1,
                    'user_create'           =>1,
                    'user_update'           =>1
                ])->id;
    
                DB::select('CALL create_stock_product(?,?,?)', 
                        [auth()->user()->id, $fecha_reg, $IDproduct]);
    
                if(trim($row['9'])!=0){
                    DB::select('CALL mov_stock_inventario(?,?,?,?)', 
                    [auth()->user()->id, $fecha_reg, $IDproduct,trim($row['9'])]);
                }
    
            }else{
                $mytime = Carbon::now();
            
                $fecha_reg=$mytime->toDateTimeString();
                
                $productSelectSTOCK = product::
                select('id')
                ->where('codigo', trim($row['2']))
                ->where('nombre', trim($row['3']))
                ->where('estado',1)
                ->get();
    
                $IDproduct=0;
                foreach($productSelectSTOCK as $rowSelectSTOCK){
                    $IDproduct =$rowSelectSTOCK->id;
                }
                if((int)trim($row['9'])!=0){
                    DB::select('CALL mov_stock_inventario(?,?,?,?)', 
                    [auth()->user()->id, $fecha_reg, $IDproduct,trim($row['9'])]);
                }
            }
        }else{

        }
        
        
        
    }
}
