<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateProductTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('product', function (Blueprint $table) {
            $table->id();
            $table->integer('id_categoria');
            $table->integer('id_marca');
            $table->longText('codigo')->nullable();
            $table->longText('nombre');
            $table->integer('id_currency');
            $table->decimal('costo', 25, 2);
            $table->decimal('precio', 25, 2);
            $table->integer('id_unit_measure');
            $table->integer('id_type_tax_product')->nullable();
            $table->integer('alerta_stock');
            $table->integer('estado');
            $table->integer('user_create');
            $table->integer('user_update')->nullable();
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('product');
    }
}
