<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Schema;

class CreateStockproductStoreProcedure extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        $store_procedure="DROP PROCEDURE IF EXISTS `create_stock_product`;
            CREATE PROCEDURE `create_stock_product` (
            IN user_id INT, 
            IN fecha_reg LONGTEXT,
            IN product_id INT)
            BEGIN

                DECLARE alamacenes_id INT;
                DECLARE cerrarLOOP INTEGER DEFAULT 0;

                DECLARE almacenes_cursor CURSOR FOR SELECT id FROM `warehouses` WHERE estado=1;

                DECLARE CONTINUE HANDLER FOR NOT FOUND SET cerrarLOOP = TRUE;

                OPEN almacenes_cursor;

                recorrer_almacenes: LOOP

                    FETCH almacenes_cursor INTO alamacenes_id;

                    IF cerrarLOOP THEN
                    LEAVE recorrer_almacenes;
                    END IF;

                    INSERT INTO `warehouses_stock`(`id_warehouses`, `id_product`, `stock`, `created_at`, `updated_at`) 
                    VALUES ( alamacenes_id, product_id, 0, fecha_reg, fecha_reg);

                END LOOP recorrer_almacenes;

                CLOSE almacenes_cursor;

            END;
        ";

        DB::unprepared($store_procedure);
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        //Schema::dropIfExists('stockproduct_store_procedure');
    }
}
