<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Schema;

class CreateStockalmacenStoreProcedure extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        $store_procedure="DROP PROCEDURE IF EXISTS `create_stock_warehouse`;
            CREATE PROCEDURE `create_stock_warehouse` (
            IN user_id INT, 
            IN fecha_reg LONGTEXT,
            IN warehouse_id INT)
            BEGIN

                DECLARE productos_id INT;
                DECLARE cerrarLOOP INTEGER DEFAULT 0;

                DECLARE productos_cursor CURSOR FOR SELECT `id` FROM `product` WHERE `estado`=1;

                DECLARE CONTINUE HANDLER FOR NOT FOUND SET cerrarLOOP = TRUE;

                OPEN productos_cursor;

                recorrer_productos: LOOP

                    FETCH productos_cursor INTO productos_id;

                    IF cerrarLOOP THEN
                    LEAVE recorrer_productos;
                    END IF;

                    INSERT INTO `warehouses_stock`(`id_warehouses`, `id_product`, `stock`, `created_at`, `updated_at`) 
                    VALUES ( warehouse_id, productos_id, 0, fecha_reg, fecha_reg);

                END LOOP recorrer_productos;

                CLOSE productos_cursor;

            END;
        ";

        DB::unprepared($store_procedure);
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        //Schema::dropIfExists('stockalmacen_store_procedure');
    }
}
