<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Schema;

class CreateStocktrasladoStoreProcedure extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        $store_procedure="DROP PROCEDURE IF EXISTS `mov_stock_warehouse`;
            CREATE PROCEDURE `mov_stock_warehouse` (
            IN user_id INT, 
            IN fecha_reg LONGTEXT,
            IN warehouse_id_salida INT,
            IN warehouse_id_ingreso INT,
            IN product_id INT,
            IN cantidad_ingreso INT)
            BEGIN

                DECLARE stock_inicial_WS INT;
                DECLARE stock_inicial_WI INT;

                SET stock_inicial_WS :=(SELECT stock FROM `warehouses_stock` WHERE id_product = product_id and id_warehouses = warehouse_id_salida);
                SET stock_inicial_WI :=(SELECT stock FROM `warehouses_stock` WHERE id_product = product_id and id_warehouses = warehouse_id_ingreso);

                UPDATE `warehouses_stock` SET `stock`=`stock` + cantidad_ingreso WHERE `id_warehouses`= warehouse_id_ingreso and`id_product`= product_id;
                UPDATE `warehouses_stock` SET `stock`=`stock` - cantidad_ingreso WHERE `id_warehouses`= warehouse_id_salida and`id_product`= product_id;

                INSERT INTO `movement_product`(`id_warehouses`, `id_product`, `stock_inicial`, `cantidad_movimiento`, `id_type_mov_product`, `user_create`,
                 `user_update`, `created_at`, `updated_at`) 
                 VALUES (warehouse_id_ingreso, product_id, stock_inicial_WI, cantidad_ingreso, 5,user_id ,user_id, fecha_reg, fecha_reg);

                 INSERT INTO `movement_product`(`id_warehouses`, `id_product`, `stock_inicial`, `cantidad_movimiento`, `id_type_mov_product`, `user_create`,
                 `user_update`, `created_at`, `updated_at`) 
                 VALUES (warehouse_id_salida, product_id, stock_inicial_WS, (-1)* (cantidad_ingreso), 6,user_id ,user_id, fecha_reg, fecha_reg);

            END;
        ";

        DB::unprepared($store_procedure);
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        //Schema::dropIfExists('stocktraslado_store_procedure');
    }
}
