<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Schema;

class CreateStockinventarioStoreProcedure extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        $store_procedure="DROP PROCEDURE IF EXISTS `mov_stock_inventario`;
            CREATE PROCEDURE `mov_stock_inventario` (
            IN user_id INT, 
            IN fecha_reg LONGTEXT,
            IN product_id INT,
            IN cantidad_ingreso INT)
            BEGIN

                DECLARE stock_inicial_WI INT;
                DECLARE tipo_mov_inventario INT;

                SET stock_inicial_WI :=(SELECT stock FROM `warehouses_stock` WHERE id_product = product_id and id_warehouses = 1);

                UPDATE `warehouses_stock` SET `stock`=`stock` + cantidad_ingreso WHERE `id_warehouses`= 1 and`id_product`= product_id;

                IF(cantidad_ingreso < 0) THEN
            
                    SET tipo_mov_inventario = 2;

                ELSE

                    SET tipo_mov_inventario = 1;

                END IF;

                INSERT INTO `movement_product`(`id_warehouses`, `id_product`, `stock_inicial`, `cantidad_movimiento`, `id_type_mov_product`, `user_create`,
                 `user_update`, `created_at`, `updated_at`) 
                 VALUES (1, product_id, stock_inicial_WI, cantidad_ingreso, tipo_mov_inventario,user_id ,user_id, fecha_reg, fecha_reg);

            END;
        ";

        DB::unprepared($store_procedure);
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        //Schema::dropIfExists('stockinventario_store_procedure');
    }
}
