<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateSalesTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('sales', function (Blueprint $table) {
            $table->id();
            $table->integer('id_customer');
            $table->longText('customer_name');
            $table->longText('dni_ruc');
            $table->integer('id_local');
            $table->integer('id_document_type_customer');
            $table->integer('document_type_catalogo06');

            $table->integer('id_type_voucher');
            $table->integer('type_voucher_catalogo01');
            $table->integer('id_way_pay');

            $table->integer('id_habitacion_aula_mesa')->nullable();

            $table->longText('placa')->nullable();
            $table->longText('orden_compra')->nullable();

            $table->longText('currency');
            $table->decimal('affected', 25, 6);
            $table->decimal('non_affected', 25, 6);
            $table->decimal('exonerated', 25, 6);
            $table->decimal('total', 25, 6);
            $table->decimal('subtotal_tax', 25, 6);
            $table->decimal('subtotal', 25, 6);

            $table->integer('igv');

            $table->integer('items_quantity');
            $table->integer('items_numeration');

            $table->longText('nota')->nullable();

            $table->longText('invoice_id');
            $table->integer('flg_response')->nullable();
            $table->integer('error_code')->nullable();
            $table->longText('response_descrip')->nullable();
            $table->longText('digest_value')->nullable();
            $table->longText('forma_pago');

            $table->integer('status_send')->nullable();

            $table->longText('file_pdf')->nullable();

            $table->integer('user_create');
            $table->integer('user_update');
            $table->integer('estado');
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('sales');
    }
}
