<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Schema;

class CreateAddSaleStoreProcedure extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        $store_procedure="DROP PROCEDURE IF EXISTS `set_post_sales_v1`;
            CREATE PROCEDURE `set_post_sales_v1` (
            IN p_id_user INT,
            IN p_id_customer INT, 
            IN p_type_comprobante INT,
            IN p_currency LONGTEXT,
            IN p_nota LONGTEXT, 
            IN p_add_way_pay INT,
            IN p_placa LONGTEXT, 
            IN p_compra LONGTEXT, 
            IN p_mesa_habit INT,
            IN p_id_local INT,
            IN p_json_items JSON)
            BEGIN

                DECLARE v_customer_name LONGTEXT;
                DECLARE v_dni INT;
                DECLARE v_ruc INT;
                DECLARE v_pasaporte LONGTEXT;
                DECLARE v_carnet LONGTEXT;
                DECLARE v_documento_customer_sales LONGTEXT;
                DECLARE v_id_document_type_customer INT;
                DECLARE v_id_catalogo_06 INT;
                DECLARE v_id_catalogo_01 LONGTEXT;
                DECLARE v_NOW DATETIME DEFAULT NOW();
                DECLARE v_id_sales BIGINT UNSIGNED;
                DECLARE v_igv DECIMAL(10,2);
                DECLARE v_items_quantity DECIMAL(10,2);
                DECLARE v_items_numeration INT;
                DECLARE v_affect_price DECIMAL(10,2);
                DECLARE v_non_affected_price DECIMAL(10,2);
                DECLARE v_exonerated_price DECIMAL(10,2);
                DECLARE v_total DECIMAL(10,2);
                DECLARE v_subtotal_tax DECIMAL(10,2);
                DECLARE v_subtotal DECIMAL(10,2);

                SELECT 
                t1.nombre,
                t1.dni,
                t1.ruc,
                t1.pasaporte,
                t1.carnet
                INTO
                v_customer_name,
                v_dni,
                v_ruc,
                v_pasaporte,
                v_carnet
                FROM customer t1
                WHERE t1.id = p_id_customer
                AND t1.estado = 1
                LIMIT 1
                ;

                SELECT 
                (t1.igv / 100)
                INTO
                v_igv
                FROM setting t1
                LIMIT 1;

                SET v_documento_customer_sales = IF(v_ruc <> '', v_ruc, IF(v_dni <> '', v_dni, IF(v_pasaporte <> '', v_pasaporte, v_carnet)));

                SET v_id_document_type_customer = IF(v_ruc <> '', 2, IF(v_dni <> '', 1, IF(v_pasaporte <> '', 4, 3)));

                SELECT 
                t1.id_catalogo_06
                INTO
                v_id_catalogo_06
                FROM type_document_customer t1
                WHERE t1.id = v_id_document_type_customer
                LIMIT 1
                ;

                SELECT 
                t1.id_catalogo_01
                INTO
                v_id_catalogo_01
                FROM type_voucher t1
                WHERE t1.id = p_type_comprobante
                LIMIT 1
                ;
                
                INSERT INTO sales(
                    id_customer, 
                    customer_name, 
                    dni_ruc, 
                    id_local,
                    id_document_type_customer, 
                    document_type_catalogo06,
                    id_type_voucher, 
                    type_voucher_catalogo01,
                    invoice_id,
                    currency, 
                    placa,
                    orden_compra,
                    id_way_pay,
                    id_habitacion_aula_mesa,
                    affected, 
                    non_affected, 
                    exonerated, 
                    total, 
                    subtotal_tax, 
                    subtotal, 
                    igv, 
                    nota, 
                    items_quantity,
                    items_numeration,
                    user_create, 
                    user_update, 
                    estado,
                    created_at,
                    updated_at
                ) VALUES (
                    p_id_customer,
                    v_customer_name,
                    v_documento_customer_sales,
                    p_id_local,
                    v_id_document_type_customer,
                    v_id_catalogo_06,
                    p_type_comprobante,
                    v_id_catalogo_01,
                    '-',
                    p_currency,
                    p_placa,
                    p_compra,
                    p_add_way_pay,
                    p_mesa_habit,
                    0,
                    0,
                    0,
                    0,
                    0,
                    0,
                    v_igv,
                    p_nota,
                    0,
                    0,
                    p_id_user,
                    p_id_user,
                    1,
                    v_NOW,
                    v_NOW
                );

                SELECT 
                t1.id
                INTO 
                v_id_sales
                FROM sales t1
                WHERE t1.user_create = p_id_user
                AND t1.created_at = v_NOW
                ORDER BY t1.created_at DESC
                LIMIT 1;

                DROP TEMPORARY TABLE IF EXISTS tt_items_sales;

                CREATE TEMPORARY TABLE IF NOT EXISTS tt_items_sales(
                    id BIGINT UNSIGNED,
                    name LONGTEXT,
                    price DECIMAL(10,2),
                    quantity DECIMAL(10,2),
                    id_type_tax BIGINT UNSIGNED,
                    id_type_unit BIGINT UNSIGNED,
                    KEY (id),
                    KEY (id_type_tax),
                    KEY (id_type_unit)
                ) (
                    SELECT 
                    t1.id,
                    t1.name, 
                    t1.price,
                    t1.quantity,
                    t1.id_type_tax,
                    t1.id_type_unit
                    FROM JSON_TABLE(p_json_items, '$[*]' COLUMNS (
                        id INT PATH '$.id',
                        name INT PATH '$.name',
                        price DECIMAL(10,2) PATH '$.price',
                        quantity DECIMAL(10,2) PATH '$.qty',
                        id_type_tax INT PATH '$.tipo_impuesto',
                        id_type_unit INT PATH '$.tipo_unidad'
                    )) AS t1
                );

                INSERT INTO sales_items( 
                    id_product, 
                    id_sales, 
                    name_product, 
                    id_unidad_produc, 
                    quantity, 
                    price,
                    affect_price, 
                    non_affected_price, 
                    exonerated_price, 
                    total, 
                    tax, 
                    subtotal_tax, 
                    subtotal, 
                    igv, 
                    estado
                ) ( 
                    SELECT
                    t1.id AS id_product, 
                    v_id_sales AS id_sales,
                    t1.name AS name_product, 
                    t1.id_type_unit AS id_unidad_produc,
                    t1.quantity,
                    t1.price,
                    IF(t1.id_type_tax = 1, (t1.price - (t1.price * v_igv)), 0) AS affect_price,
                    IF(t1.id_type_tax = 2, t1.price, 0) AS non_affected_price,
                    IF(t1.id_type_tax = 3, t1.price, 0) AS exonerated_price,
                    (t1.price * t1.quantity) AS total,
                    IF(t1.id_type_tax = 1, (t1.price * v_igv), 0) tax,
                    IF(t1.id_type_tax = 1, ((t1.price * v_igv) * t1.quantity), 0) subtotal_tax,
                    IF(t1.id_type_tax = 1, ((t1.price - (t1.price * v_igv)) * t1.quantity), (t1.price * t1.quantity)) subtotal,
                    IF(t1.id_type_tax = 1,  v_igv, 0) igv,
                    1
                    FROM tt_items_sales t1
                );

                SELECT 
                SUM(t1.quantity),
                COUNT(t1.quantity),
                SUM(t1.affect_price),
                SUM(t1.non_affected_price),
                SUM(t1.exonerated_price),
                SUM(t1.total),
                SUM(t1.subtotal_tax),
                SUM(t1.subtotal)
                INTO
                v_items_quantity,
                v_items_numeration,
                v_affect_price,
                v_non_affected_price,
                v_exonerated_price,
                v_total,
                v_subtotal_tax,
                v_subtotal
                FROM sales_items t1
                WHERE t1.id_sales = v_id_sales;

                UPDATE sales t1
                LEFT JOIN local t2 ON t2.id = t1.id_local
                SET
                t1.items_quantity = v_items_quantity,
                t1.items_numeration = v_items_numeration,
                t1.affected = v_affect_price,
                t1.non_affected = v_non_affected_price,
                t1.exonerated = v_exonerated_price,
                t1.total = v_total,
                t1.subtotal_tax = v_subtotal_tax,
                t1.subtotal = v_subtotal,
                t1.invoice_id = IF(t1.id_type_voucher = 1, 
                                    (CONCAT(REPLACE (t2.cotizacion_format,'{0000}',''),LPAD((t2.cotizacion_correl + 1),4,'0'))), 
                                    IF(t1.id_type_voucher = 2, 
                                        (CONCAT(REPLACE (t2.notaVenta_format,'{0000000}',''),LPAD((t2.notaVenta_correl + 1),7,'0'))),
                                        IF(t1.id_type_voucher = 3, 
                                            (CONCAT(REPLACE (t2.boleta_format,'{0000000}',''),LPAD((t2.boleta_correl + 1),7,'0'))), 
                                            (CONCAT(REPLACE (t2.factura_format,'{0000000}',''),LPAD((t2.factura_correl + 1),7,'0')))
                                        ) 
                                    )
                                ),
                t2.cotizacion_correl = IF(t1.id_type_voucher = 1, (t2.cotizacion_correl + 1), t2.cotizacion_correl),
                t2.notaVenta_correl = IF(t1.id_type_voucher = 2, (t2.notaVenta_correl + 1), t2.notaVenta_correl),
                t2.boleta_correl = IF(t1.id_type_voucher = 3, (t2.boleta_correl + 1), t2.boleta_correl),
                t2.factura_correl = IF(t1.id_type_voucher = 4, (t2.factura_correl + 1), t2.factura_correl)
                WHERE t1.id = v_id_sales
                ;

            END;
        ";

        DB::unprepared($store_procedure);
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        //Schema::dropIfExists('add_sale_store_procedure');
    }
}
