<?php

namespace Database\Seeders;

use Illuminate\Database\Seeder;

use Spatie\Permission\Models\Role;
use Spatie\Permission\Models\Permission;

class RoleSeeder extends Seeder
{
    /**
     * Run the database seeds.
     *
     * @return void
     */
    public function run()
    {
        $role1 = Role::create(['name'=>'Administrador']);
        $role2 = Role::create(['name'=>'Vendedor']);

        Permission::create(['name'=>'home', 'descripcion'=>'ver Dashboard'])->syncRoles([$role1, $role2]);
        Permission::create(['name'=>'general.add_ventas', 'descripcion'=>'Agregar Ventas'])->syncRoles([$role1, $role2]);

        /*Permission::create(['name'=>'Admin.user.index'])->syncRoles([$role1]);
        Permission::create(['name'=>'Admin.user.create'])->syncRoles([$role1]);
        Permission::create(['name'=>'Admin.user.edit'])->syncRoles([$role1]);
        Permission::create(['name'=>'Admin.user.destroy'])->syncRoles([$role1]);*/
        Permission::create(['name'=>'Admin.user', 'descripcion'=>'Modulo Usuarios'])->syncRoles([$role1]);
        Permission::create(['name'=>'Admin.permisos', 'descripcion'=>'Modulo Perfiles'])->syncRoles([$role1]);
        Permission::create(['name'=>'Admin.almacen', 'descripcion'=>'Modulo Almacenes'])->syncRoles([$role1]);
        Permission::create(['name'=>'Admin.mark', 'descripcion'=>'Modulo Marcas'])->syncRoles([$role1]);
        Permission::create(['name'=>'Admin.category', 'descripcion'=>'Modulo Categorias'])->syncRoles([$role1]);
        Permission::create(['name'=>'Admin.product', 'descripcion'=>'Modulo Productos'])->syncRoles([$role1]);
        Permission::create(['name'=>'Admin.add_traslado', 'descripcion'=>'Agregar Traslados'])->syncRoles([$role1]);
        Permission::create(['name'=>'Admin.local', 'descripcion'=>'Modulo Locales'])->syncRoles([$role1]);
        Permission::create(['name'=>'Admin.customer', 'descripcion'=>'Modulo Clientes - Padres'])->syncRoles([$role1]);
        Permission::create(['name'=>'Admin.idenAlum', 'descripcion'=>'Modulo Identificador - Alumnos'])->syncRoles([$role1]);
        Permission::create(['name'=>'Admin.habAulaMesa', 'descripcion'=>'Modulo Habitación - Aula - Mesa'])->syncRoles([$role1]);
        Permission::create(['name'=>'Admin.matriAlqCuenta', 'descripcion'=>'Modulo Matricula - Cuenta - Alquiler'])->syncRoles([$role1]);

    }
}
