<div>
    <input type="text" wire:model="addproduct" class="form-control mt-1" wire:keydown.enter="add_car" id="add_product" name="add_product" placeholder="nombre o codigo de producto">
    <div class="position-relative autocomplete-div">
        <div class="position-absolute w-100 bg-white">
            @foreach ($result as $row)
                <div class="p-2 border hover-div" wire:click="select_autocomplete({{$row->id}})">{{$row->name}}</div>
            @endforeach
        </div>
    </div>
    <div class="overflow-hidden">
        <div class="mt-2 border">
            <div class="p-2 mx-1">
                <div class="h6">
                    <div class="row">
                        <div class="col-2 p-2 text-center bg-light font-weight-bold">Unidad</div>
                        <div class="col-4 p-2 text-center bg-light font-weight-bold">Producto</div>
                        <div class="col-2 p-2 text-center bg-light font-weight-bold">Impuesto</div>
                        <div class="col-1 p-2 text-center bg-light font-weight-bold">Cant.</div>
                        <div class="col-1 p-2 text-center bg-light font-weight-bold">Precio</div>
                        <div class="col-1 p-2 text-center bg-light font-weight-bold">Importe</div>
                        <div class="col-1 p-2 text-center bg-light font-weight-bold"><i class="fa fa-trash"></i></div>    
                    </div>   
                    @if (count($datosSistem['carrito']))
                        @foreach ($datosSistem['carrito'] as $carrito)
                            <div class="row">
                                <div class="col-2 text-center">
                                    <select name="" id="" class="form-control form-control-sm" wire:model="unit_carrito.{{$carrito->rowId}}" wire:change="edit_unit_cart('{{$carrito->rowId}}')">
                                        @foreach ($datosSistem['unit_measure'] as $unit_measure)
                                            <option value="{{$unit_measure->id}}">{{$unit_measure->descripcion}}</option>
                                        @endforeach
                                    </select>
                                </div>
                                <div class="col-4 text-right">{{$carrito->name}} ({{$carrito->options->codigo}})</div>
                                <div class="col-2 text-center">
                                    <select name="" id="" class="form-control form-control-sm" wire:model="impuesto_carrito.{{$carrito->rowId}}" wire:change="edit_impuesto_cart('{{$carrito->rowId}}')">
                                        @foreach ($datosSistem['type_tax_Product'] as $type_tax_Product)
                                            <option value="{{$type_tax_Product->id}}">{{$type_tax_Product->descripcion}}</option>
                                        @endforeach
                                    </select>
                                </div>
                                <div class="col-1 text-center"><input class="form-control form-control-sm" type="text" value="{{$carrito->qty}}" wire:model="cantidad_carrito.{{$carrito->rowId}}" wire:change="edit_cant_cart('{{$carrito->rowId}}')"></div>
                                <div class="col-1 text-center"><input class="form-control form-control-sm" type="text" value="{{$carrito->price}}" wire:model="precio_carrito.{{$carrito->rowId}}" wire:change="edit_precio_cart('{{$carrito->rowId}}')"></div>
                                <div class="col-1 text-center">{{number_format(($carrito->price * $carrito->qty), 2)}}</div>
                                <div class="col-1 text-center"><button class="btn btn-danger" wire:click="deleted_cart('{{$carrito->rowId}}')"><i class="fa fa-trash"></i></button></div>
                            </div>
                        @endforeach
                    @else
                        <div class="row">
                            <div class="col-12 p-2 d-flex align-items-center justify-content-center">Agregar el producto a través de la búsqueda en el campo de arriba</div>
                        </div>
                    @endif
                    
                </div>
                <div class="row">
                    <div class="col-6 p-2 text-center bg-light font-weight-bold">SUB-TOTALES</div>
                    <div class="col-2 p-2 text-center bg-light font-weight-bold">{{Cart::content()->count()}} ({{Cart::count()}})</div>
                    <div class="col-2 p-2 text-center bg-light font-weight-bold">{{number_format($total_precio_unit, 2)}}</div>
                    <div class="col-1 p-2 text-center bg-light font-weight-bold">{{Cart::total()}}</div>
                    <div class="col-1 p-2 bg-light"></div>
                </div>
                <div class="row">
                    <div class="col-10 p-2 text-right">OP. GRAVADAS:</div>
                    <div class="col-1 p-2 text-center">{{number_format(($gravadas-($gravadas * 0.18)),2)}}</div>
                    <div class="col-1 p-2 "></div>
                </div>
                <div class="row">
                    <div class="col-10 p-2 text-right">OP. EXONERADAS:</div>
                    <div class="col-1 p-2 text-center">{{number_format($exonerados,2)}}</div>
                    <div class="col-1 p-2 "></div>
                </div>
                <div class="row">
                    <div class="col-10 p-2 text-right">OP. INAFECTAS:</div>
                    <div class="col-1 p-2 text-center">{{number_format($inafectos,2)}}</div>
                    <div class="col-1 p-2 "></div>
                </div>
                <div class="row">
                    <div class="col-10 p-2 text-right">IGV - {{number_format($igv_carrito,0)}}%:</div>
                    <div class="col-1 p-2 text-center">{{number_format(($gravadas * $igv_carrito / 100),2)}}</div>
                    <div class="col-1 p-2 "></div>
                </div>
                <div class="row">
                    <div class="col-10 p-2 text-right bg-light font-weight-bold">IMPORTE TOTAL:</div>
                    <div class="col-1 p-2 text-center bg-light">{{Cart::total()}}</div>
                    <div class="col-1 p-2 bg-light"></div>
                </div>
            </div>
        </div>
    </div>
</div>
