<?php

use App\Http\Controllers\categoryController;
use App\Http\Controllers\customerController;
use App\Http\Controllers\habitacionaulamesaController;
use App\Http\Controllers\identificadorAlumnoController;
use App\Http\Controllers\localController;
use App\Http\Controllers\markController;
use App\Http\Controllers\matriculaalquilercuentaController;
use App\Http\Controllers\permisosAdminController;
use App\Http\Controllers\productController;
use App\Http\Controllers\sessionController;
use App\Http\Controllers\trasladosController;
use App\Http\Controllers\userAdminController;
use App\Http\Controllers\ventaController;
use App\Http\Controllers\warehouseController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [sessionController::class, 'home'])->name('home')->middleware('auth');
Route::get('home', [sessionController::class, 'inicio'])->name('home.default')->middleware('auth');

Route::get('login', [sessionController::class, 'index'])->name('login')->middleware('guest');

Route::post('inicioSession', [sessionController::class, 'login'])->name('inicioSession.index');

Route::get('cerrarSession', [sessionController::class, 'logout'])->name('logout.index');

Route::get('Usuarios', [userAdminController::class, 'index'])->middleware('can:Admin.user')->name('Admin.user')->middleware('auth');

Route::get('Permisos', [permisosAdminController::class, 'index'])->middleware('can:Admin.permisos')->name('Admin.permisos')->middleware('auth');

Route::get('Almacenes', [warehouseController::class, 'index'])->middleware('can:Admin.almacen')->name('Admin.almacen')->middleware('auth');

Route::get('Marcas', [markController::class, 'index'])->middleware('can:Admin.mark')->name('Admin.mark')->middleware('auth');

Route::get('Categorias', [categoryController::class, 'index'])->middleware('can:Admin.category')->name('Admin.category')->middleware('auth');

Route::get('Productos', [productController::class, 'index'])->middleware('can:Admin.product')->name('Admin.product')->middleware('auth');

Route::get('Traslado/{id}', [trasladosController::class, 'index'])->middleware('can:Admin.add_traslado')->name('Admin.add_traslado')->middleware('auth');

Route::get('Locales', [localController::class, 'index'])->middleware('can:Admin.local')->name('Admin.local')->middleware('auth');

Route::get('Clientes', [customerController::class, 'index'])->middleware('can:Admin.customer')->name('Admin.customer')->middleware('auth');
Route::get('Padres', [customerController::class, 'index'])->middleware('can:Admin.customer')->name('Admin.fathers')->middleware('auth');

Route::get('Alumno', [identificadorAlumnoController::class, 'alumno'])->middleware('can:Admin.idenAlum')->name('Admin.Alum')->middleware('auth');
Route::get('Identificador', [identificadorAlumnoController::class, 'indentificador'])->middleware('can:Admin.idenAlum')->name('Admin.iden')->middleware('auth');

Route::get('Habitacion', [habitacionaulamesaController::class, 'habitacion'])->middleware('can:Admin.habAulaMesa')->name('Admin.hab')->middleware('auth');
Route::get('Mesa', [habitacionaulamesaController::class, 'mesa'])->middleware('can:Admin.habAulaMesa')->name('Admin.mesa')->middleware('auth');
Route::get('Aula', [habitacionaulamesaController::class, 'aula'])->middleware('can:Admin.habAulaMesa')->name('Admin.aula')->middleware('auth');

Route::get('Mesas_clientes', [matriculaalquilercuentaController::class, 'asignar_mesa'])->middleware('can:Admin.matriAlqCuenta')->name('Admin.asigMesa')->middleware('auth');
Route::get('Habitacion_clientes', [matriculaalquilercuentaController::class, 'asignar_habitacion'])->middleware('can:Admin.matriAlqCuenta')->name('Admin.asigHabit')->middleware('auth');
Route::get('Matricula', [matriculaalquilercuentaController::class, 'asignar_seccion'])->middleware('can:Admin.matriAlqCuenta')->name('Admin.matricu')->middleware('auth');

Route::get('Agregar_venta', [ventaController::class, 'sale'])->middleware('can:general.add_ventas')->name('add_ventas')->middleware('auth');

Route::post('registrar_venta', [ventaController::class, 'add_sale'])->name('register_sales.index');
